﻿using System;

using Android.App;
using Android.Content;
using Android.Provider;

using Xamarin.Forms;

[assembly: Dependency(typeof(AlignmentViewer.Droid.CameraService))]
namespace AlignmentViewer.Droid
{
    class CameraService : ICameraService
    {
        public void takePhoto()
        {
            try
            {
                Intent intent = new Intent(MediaStore.ActionImageCapture);
                Intent takePictureIntent = new Intent(MediaStore.ActionImageCapture);

                if (takePictureIntent.ResolveActivity(Forms.Context.PackageManager) != null)
                {
                    Java.IO.File cameraFile = null;
                    try
                    {
                        var documentsDirectory = Forms.Context.GetExternalFilesDir(Android.OS.Environment.DirectoryPictures);
                        cameraFile = new Java.IO.File(documentsDirectory, "TempPictureFile" + ".jpg");

                        if (cameraFile != null)
                        {
                            using (var mediaStorageDir = new Java.IO.File(documentsDirectory, string.Empty))
                            {
                                if (!mediaStorageDir.Exists())
                                {
                                    if (!mediaStorageDir.Mkdirs())
                                    {
                                        MessagingCenter.Send<string>("Permissions", "PhotoFailed");
                                    }
                                }
                            }
                        }
                    }
                    catch (Exception e)
                    {
                        App.StackTrace = e.StackTrace;
                        MessagingCenter.Send<string>(e.Message, "PhotoFailed");
                    }

                    Android.Net.Uri photoUri = Android.Support.V4.Content.FileProvider.GetUriForFile(((Activity)Forms.Context), "com.nrgsurveys.alignmentViewer.fileprovider", cameraFile);
                    takePictureIntent.PutExtra(MediaStore.ExtraOutput, photoUri);
                    ((Activity)Forms.Context).StartActivityForResult(takePictureIntent, 0);
                }
            }
            catch(Exception e)
            {
                App.StackTrace = e.StackTrace;
                MessagingCenter.Send<string>(e.Message, "PhotoFailed");
            }
        }
    }
}