﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.Media;
using Android.Locations;
using System.Threading.Tasks;

namespace AlignmentViewer.Droid
{
    class PostCodeUtils : MainPage.IPostCodeSearch
    {
        public async Task<string> getPostCode(double lat, double lng)
        {
            try
            {
                bool test = Geocoder.IsPresent;
                if (test == true)
                {
                    var geo = new Geocoder(Application.Context);
                    var placemarks = await geo.GetFromLocationAsync(lat, lng, 1);
                    return placemarks.First().PostalCode;
                }
                else
                    return null;
            }
            catch(Exception e)
            {
                Console.WriteLine(e.Message);
                return null;
            }
        }
   
        public async Task<string> getLocation(string pCode, string cCode)
        {
            try
            {
                bool test = Geocoder.IsPresent;
                if (test == true)
                {
                    var geo = new Geocoder(Application.Context);
                    var placemarks = await geo.GetFromLocationNameAsync(pCode + "," + cCode, 1);
                    return placemarks.First().Latitude.ToString() + "," + placemarks.First().Longitude.ToString();
                }
                else
                    return null;
            }
            catch(Exception e)
            {
                Console.WriteLine(e.Message);
                return null;
            }
        }
    }
}