﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Foundation;
using UIKit;
using CoreLocation;
using System.Threading.Tasks;

namespace AlignmentViewer.iOS
{
    class PostCodeUtils : MainPage.IPostCodeSearch
    {
        public async Task<string> getPostCode(double lat, double lng)
        {
            try
            {
                var geo = new CLGeocoder();
                var placemarks = await geo.ReverseGeocodeLocationAsync(new CLLocation(lat, lng));
                return placemarks.First().PostalCode;
            }
            catch(Exception e)
            {
                Console.WriteLine(e.Message);
                return null;
            }
        }

        public async Task<string> getLocation(string pCode, string cCode)
        {
            try
            {
                var geo = new CLGeocoder();
                var placemarks = await geo.GeocodeAddressAsync(pCode + "," + cCode);
                return placemarks.First().Location.Coordinate.Latitude.ToString() + "," + placemarks.First().Location.Coordinate.Longitude.ToString();
            }
            catch(Exception e)
            {
                Console.WriteLine(e.Message);
                return null;
            }
        }
    }
}