﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Foundation;
using UIKit;
using Xamarin.Forms;
using Xamarin.Forms.Platform.iOS;
using CoreGraphics;

[assembly: ExportRenderer(typeof(AlignmentViewer.borderlessEntry), typeof(AlignmentViewer.iOS.borderlessEntryRenderer))]
namespace AlignmentViewer.iOS
{
    public class borderlessEntryRenderer : EntryRenderer
    {
        protected override void OnElementChanged(ElementChangedEventArgs<Entry> e)
        {
            base.OnElementChanged(e);

            if (Control != null)
            {
                //Removes background
                Control.Background = null;
                Control.LeftView = new UIView(new CGRect(0, 0, 0, 0));
                Control.RightView = new UIView(new CGRect(0, 0, 0, 0));
                Control.LeftViewMode = UITextFieldViewMode.Always;
                Control.RightViewMode = UITextFieldViewMode.Always;
                Control.BorderStyle = UITextBorderStyle.None;


                //Adds done button to keyboard
                var toolbar = new UIToolbar(new CGRect(0.0f, 0.0f, Control.Frame.Size.Width, 44.0f));

                toolbar.Items = new[]
                {
                    new UIBarButtonItem(UIBarButtonSystemItem.FlexibleSpace),
                    new UIBarButtonItem(UIBarButtonSystemItem.Done, delegate {Control.ResignFirstResponder(); })
                };

                Control.InputAccessoryView = toolbar;

                //Removes keyboard suggestions
                //Control.SpellCheckingType = UITextSpellCheckingType.No;
                Control.AutocorrectionType = UITextAutocorrectionType.No;
                Control.AutocapitalizationType = UITextAutocapitalizationType.None;
            }
        }
    }

}