﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Foundation;
using UIKit;
using Xamarin.Forms;
using Xamarin.Forms.Platform.iOS;
using CoreGraphics;

[assembly: ExportRenderer(typeof(AlignmentViewer.borderlessNumberEntry), typeof(AlignmentViewer.iOS.borderlessNumberEntryRenderer))]
namespace AlignmentViewer.iOS
{
    public class borderlessNumberEntryRenderer : EntryRenderer
    {
        protected override void OnElementChanged(ElementChangedEventArgs<Entry> e)
        {
            base.OnElementChanged(e);

            if (Control != null)
            {
                Control.Background = null;
                Control.LeftView = new UIView(new CGRect(0, 0, 0, 0));
                Control.RightView = new UIView(new CGRect(0, 0, 0, 0));
                Control.LeftViewMode = UITextFieldViewMode.Always;
                Control.RightViewMode = UITextFieldViewMode.Always;
                Control.BorderStyle = UITextBorderStyle.None;

                //Adds done button
                var toolbar = new UIToolbar(new CGRect(0.0f, 0.0f, Control.Frame.Size.Width, 44.0f));

                toolbar.Items = new[]
                {
                    new UIBarButtonItem("-", UIBarButtonItemStyle.Plain, AddBarButtonText),
                    new UIBarButtonItem(UIBarButtonSystemItem.FlexibleSpace),
                    new UIBarButtonItem(UIBarButtonSystemItem.Done, delegate { Control.ResignFirstResponder(); })
                };

                Control.InputAccessoryView = toolbar;

                //Removes keyboard suggestions
                Control.AutocorrectionType = UITextAutocorrectionType.No;
                Control.AutocapitalizationType = UITextAutocapitalizationType.None;
            }
        }

        public void AddBarButtonText(object sender, EventArgs e)
        {
            var barButtonItem = sender as UIBarButtonItem;
            if (barButtonItem != null)
                Control.Text += barButtonItem.Title;
        }

    }
}