﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;
using Plugin.Permissions;
using Plugin.Permissions.Abstractions;
using Plugin.Geolocator;
using System.Diagnostics;
using Xamarin.Forms.GoogleMaps;
using System.Globalization;
using System.Threading;


//[assembly: XamlCompilation (XamlCompilationOptions.Compile)]
namespace AlignmentViewer
{
    public enum Unit
    {
        None,
        Metre,
        Foot,
        USFoot,
    }

    public enum ScaleFactor
    {
        Multiply,
        Divide
    }

    public partial class App : Application
    {
        //Plugin.Geolocator.Abstractions.IGeolocator locator;
        string dataPath = "";

        public static MainPage.IPostCodeSearch PostCodeSearch { get; private set; }
        public static MainPage.IScanFiles ScanFiles { get; private set; }
        public static MainPage.ISetupSampleData SetupFiles { get; private set; }
        public static workspace nrgWorkspace = new workspace();
        public static int screenWidth;
        public static int screenHeight;
        public static string internalPath;
        public static string externalPath;
        public static int density;
        public static string hdop;
        public static double lat;
        public static double lng;
        public static string alignment;
        public static string ch;
        public static string photoName;
        public static string off;
        public static double chValue;
        public static double offValue;
        public static string Acc;
        public static string Date;
        public static string Time;
        public static string StringName;
        public static int watermarkSize;
        public static int watermarkPosition;
        public static string transformationBody;
        public static string transformationString;
        public static bool IsPhotoNameIncrmented = false;
        public static int PhotoNameIncrement = 1;
        public static bool watermarkShowAcc = false;
        public static bool watermarkShowDate = false;
        public static bool watermarkShowString = false;
        public static int watermarkDateFormat = 0;
        public static int watermarkTimeFormat = 0;
        public static string StackTrace = "";
        public static Unit DefaultUnits = Unit.None;
        public static Unit SavedUnits = Unit.None;
        public static ScaleFactor ScaleFactorMethod = ScaleFactor.Multiply;
        public static double AccuracyThreshold = 5;
        public static double Accuracy = 0;

        public App(string newDataPath)
        {
            InitializeComponent();
            dataPath = newDataPath;

            nrgWorkspace.startLocator();
            nrgWorkspace.datapath = dataPath;

            CultureInfo englishCulture = new CultureInfo("en-US");
            CultureInfo.DefaultThreadCurrentCulture = englishCulture;

            MainPage = new NavigationPage(new MainPage(ref nrgWorkspace));
        }

        public static void Init(MainPage.IPostCodeSearch postCodeSearch, MainPage.IScanFiles scanFiles, MainPage.ISetupSampleData setupSampleData)
        {
            App.PostCodeSearch = postCodeSearch;
            App.ScanFiles = scanFiles;
            App.SetupFiles = setupSampleData;
        }
    }
}

