﻿using System;
using System.Collections.Generic;

using System.Text;
using System.IO;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using Xamarin.Forms;
using System.Threading.Tasks;
using Xamarin.Forms.GoogleMaps;
using nrgFileRead;
using static AlignmentViewer.workspace;

namespace AlignmentViewer
{
    public class helpers
    {
        ///Secret File Making
        ///
        /* Secret Files

      ~7726420.gpf = gpffile
      ~7726423.gpf = created file
      ~7726424.gpf = cance

          */

        public static double infinity()
        {
            return double.PositiveInfinity;
        }

        public double DegreeToRadian(double angle)
        {
            return Math.PI * angle / 180.0;
        }


        public double RadianToDegree(double angle)
        {
            return angle * (180.0 / Math.PI);
        }

  

       

        public static int paddingCalc(dataTypes.nrgVector3Bounds bounds, int pixelWidth, int pixelHeight, int amount = 50)
        {
            double hC = 0d;
            if (bounds.maxX > bounds.maxY)
            {
                hC = ((bounds.maxX - bounds.minX) / pixelWidth) * amount;
            }
            else
            {
                hC = ((bounds.maxY - bounds.minY) / pixelHeight) * amount;

            }
            if (hC < 1)
                hC = 2;
            return (int)hC;
        }

        public static double convertMXNumberToDouble(string stringNumber)
        {
            var testString = stringNumber;
            //-.50316344289540546D+06
            //0.21491872849681350D+02
            bool isMinus = false;
            double newNumber = 0;
            string newNumberString = stringNumber;
            if (newNumberString.Contains("-"))
            {
                newNumberString = newNumberString.Replace("-", "0");
                isMinus = true;
            }
            newNumberString = newNumberString.Replace("+", "");
            newNumberString = newNumberString.Replace('D', 'E');
            newNumberString = newNumberString.Replace('F', 'E');
            newNumberString = newNumberString.Replace("E0", "E");

            if (!double.TryParse(newNumberString, System.Globalization.NumberStyles.Float, CultureInfo.InvariantCulture, out newNumber))
            {
               
            }
            if (isMinus)
            {
                newNumber = -newNumber;
            }

            if (newNumber < 1 && newNumber > -0.001 && !testString.Contains("0.0000000"))
            {
              
            }
            return newNumber;
        }


        public static int findNearestVector3InList(dataTypes.nrgVector3 searchPoint, ref List<dataTypes.nrgVector3> pointsList)
        {
            double currentDistance = 9999999999999;
            double distance = 9999999999;
            int foundPointIndex = 0;
            int pointIndex = 0;
            foreach (dataTypes.nrgVector3 point in pointsList)
            {

                double a = (double)(searchPoint.X - point.X);
                double b = (double)(searchPoint.Y - point.Y);
                currentDistance = Math.Sqrt(a * a + b * b);

                if ((currentDistance < distance))
                {
                    distance = currentDistance;
                    foundPointIndex = pointIndex;
                }
                pointIndex++;
            }
            return foundPointIndex;
        }

        public static int findNearestVector3InList(dataTypes.nrgVector3 searchPoint, ref List<dataTypes.nrgSimplePoint> pointsList)
        {
            double currentDistance = 9999999999999;
            double distance = 9999999999;
            int foundPointIndex = 0;
            int pointIndex = 0;
            foreach (dataTypes.nrgSimplePoint point in pointsList)
            {

                double a = (double)(searchPoint.X - point.coord.X);
                double b = (double)(searchPoint.Y - point.coord.Y);
                currentDistance = Math.Sqrt(a * a + b * b);

                if ((currentDistance < distance))
                {
                    distance = currentDistance;
                    foundPointIndex = pointIndex;
                }
                pointIndex++;
            }
            return foundPointIndex;
        }

        #region Used to parse a "/B/ST /PT/S2.0/W1.0" style string into the field code list object and back again
        public static List<dataTypes.fieldCode> importFieldCodeStringToList(string inputCodeString)
        {
            List<string> switchIgnoreList = new List<string> { "+", "-" };

            List<dataTypes.fieldCode> outputCodeList = new List<dataTypes.fieldCode>();
            String majorCodeString = "";

            //Split coding up by space to get individual major coding
            string[] fieldCodeArray = inputCodeString.ToUpper().TrimEnd(' ').Split(new string[] { " " }, StringSplitOptions.None);

            foreach (string fieldCodeString in fieldCodeArray)
            {
                bool isBreakLine = false;
                //split each part to find major and command switch
                string[] fieldCodeElementArray = fieldCodeString.Split(new string[] { "/" }, StringSplitOptions.None);
                majorCodeString = fieldCodeElementArray[0].ToString();

                //Check to see if breakline (from features ini)
                isBreakLine = checkIfBreakLine(majorCodeString);
                string newCode = "";
                //check if any switches
                List<dataTypes.codeSwitch> importCodeSwitchList = new List<dataTypes.codeSwitch>();
                if (fieldCodeElementArray.GetLength(0) > 1)
                    if (fieldCodeElementArray[1].Length > 0)
                    {
                        for (int switchCount = 1; switchCount < fieldCodeElementArray.GetLength(0); switchCount++)
                        {
                            newCode = "";
                            //Do a pile of clean up and only import recognised switched
                            if (fieldCodeElementArray[switchCount].Contains("ST"))
                                newCode = "ST";
                            if (fieldCodeElementArray[switchCount].Contains("STCV"))
                                newCode = "";
                            if (fieldCodeElementArray[switchCount].Contains("RGB"))
                                newCode = fieldCodeElementArray[switchCount];

                            if (fieldCodeElementArray[switchCount].Contains("CL"))
                                newCode = "CL";
                            if (fieldCodeElementArray[switchCount].Contains("TR"))
                                newCode = "";
                            if (fieldCodeElementArray[switchCount].Contains("TX"))
                                newCode = "";
                            if (fieldCodeElementArray[switchCount].Contains("TY"))
                                newCode = "";
                            if (fieldCodeElementArray[switchCount][0].Equals('-'))
                                newCode = "-";
                            if (fieldCodeElementArray[switchCount][0].Equals('+'))
                                newCode = "-";

                            if (newCode.Length > 0)
                                importCodeSwitchList.Add(new dataTypes.codeSwitch { code = newCode });
                            //need to do some kind of check to split the value out here, only puting whole switch+value into code string at moment
                        }
                    }
                outputCodeList.Add(new dataTypes.fieldCode { majorCode = majorCodeString, codeSwitchList = importCodeSwitchList, isBreakLine = isBreakLine });
            }
            return outputCodeList;
        }


        
        public static int RGBtoInt(int ir, int ig, int ib)
        {


            //Create Empty Colour
            int colourOutput = 0;
            int r = ib;
            int g = ig;
            int b = ir;
            if (r < 0) r = 0;
            if (g < 0) g = 0;
            if (b < 0) b = 0;

            int rgb = r;
            rgb = (rgb << 8) + g;
            rgb = (rgb << 8) + b;
            colourOutput = rgb;


            return colourOutput;
        }


        

        public static List<dataTypes.fieldCode> parseFieldCodeStringToList(string inputCodeString)
        {
            List<dataTypes.fieldCode> outputCodeList = new List<dataTypes.fieldCode>();
            String majorCodeString = "";

            //Split coding up by space to get individual major coding
            string[] fieldCodeArray = inputCodeString.ToUpper().TrimEnd(' ').Split(new string[] { " " }, StringSplitOptions.None);

            foreach (string fieldCodeString in fieldCodeArray)
            {
                bool isBreakLine = false;
                //split each part to find major and command switch
                string[] fieldCodeElementArray = fieldCodeString.Split(new string[] { "/" }, StringSplitOptions.None);
                majorCodeString = fieldCodeElementArray[0].ToString();

                //Check to see if breakline (from features ini)
                isBreakLine = checkIfBreakLine(majorCodeString);

                //check if any switches
                List<dataTypes.codeSwitch> importCodeSwitchList = new List<dataTypes.codeSwitch>();
                if (fieldCodeElementArray.GetLength(0) > 1)
                {
                    for (int switchCount = 1; switchCount < fieldCodeElementArray.GetLength(0); switchCount++)
                    {
                        //need to do some kind of check to split the value out here, only puting whole switch+value into code string at moment
                        importCodeSwitchList.Add(new dataTypes.codeSwitch { code = fieldCodeElementArray[switchCount].ToString() });
                    }

                }
                outputCodeList.Add(new dataTypes.fieldCode { majorCode = majorCodeString, codeSwitchList = importCodeSwitchList, isBreakLine = isBreakLine });
            }
            return outputCodeList;
        }
        public static string parseFieldCodeListToString(List<dataTypes.fieldCode> fieldCodeList)
        {
            string outputString = "";
            foreach (dataTypes.fieldCode fieldCode in fieldCodeList)
            {
                outputString = outputString + fieldCode.majorCode;

                foreach (dataTypes.codeSwitch switchCode in fieldCode.codeSwitchList)
                {
                    outputString = outputString + "/";
                    outputString = outputString + switchCode.code;
                }
                outputString = outputString + " ";
            }

            return outputString;

        }
        public static bool checkIfBreakLine(string featureCodeString)
        {
            bool isBreakline = false;

            List<string> listOfStrings = new List<string> { "LS", "PK", "PZ", "PG", "PGA", "PGA", "PHS", "PW", "PGMC", "PI", "PH", "PP", "PP", "PR", "PS", "PD", "PB", "PIB", "NULL", "LE", "PC", "PCTV", "PFL", "PSP", "BOL", "PBA", "PBH", "PBIN", "PCO", "PCU", "PDE", "PEB", "PEP", "PER", "PES", "PFH", "PGR", "PGS", "PGL", "PGU", "PGV", "PHT", "PIC", "PINV", "PIR", "PIS", "PIT", "PL", "PLP", "PMA", "PMR", "PMS", "PMT", "PNT", "POB", "POS", "POST", "POT", "PPY", "PRE", "PRG", "PSC", "PSE", "PSL", "PSN", "PSS", "PSV", "PT", "PT1", "PT2", "PT3", "PTB", "PTM", "PTNL", "PTP", "PTR", "PTS", "PWM", "PWR", "PWS", "PRS", "PMK" };
            bool b = listOfStrings.Any((featureCodeString.ToUpper() + "        ").Substring(0, 4).Contains);

            if (b == false)
                b = featureCodeString.Equals("L");

            isBreakline = !b;
            return isBreakline;

        }
        #endregion

        public static void exportVectorListToGPF(ref List<dataTypes.nrgVector3> points, string filename)
        {
            StringBuilder gpfLine = new StringBuilder();
            gpfLine.AppendLine(";NRG GROUND PLOT FILE VERSION 2");

            int pointNumber = 0;
            foreach (dataTypes.nrgVector3 point in points)
            {
                gpfLine.Append(pointNumber);
                gpfLine.Append(@",""");
                gpfLine.Append("PS");
                gpfLine.Append(@""",");
                gpfLine.Append(point.X);
                gpfLine.Append(",");
                gpfLine.Append(point.Y);
                gpfLine.Append(",");
                gpfLine.Append(point.Z);
                gpfLine.Append(@",""");
                gpfLine.Append("");
                gpfLine.AppendLine(@"""");
                pointNumber++;
            }
          



        }

        public static bool inPoly2(List<dataTypes.nrgVector3> polyPoints, dataTypes.nrgVector3 checkPoint)
        {
            bool isInPoly = false;
            int il = 0;
            int i = 0;
            // start and endpoints of a line seg
            double sx = 0;
            double sy = 0;
            double ex = 0;
            double ey = 0;
            int crossings = 0;

            int numLasso = polyPoints.Count;

            //if we have less than two points we don't have much of a polygon, so exit
            if (numLasso < 2)
                return false;

            crossings = 0;
            // go through each line segement in the polygon
            for (i = 0; i < numLasso; i++)
            {
                // get the start and end points of the line relative to origin X,Y
                il = i - 1;
                if (il == -1)
                    il = numLasso - 1;
                sx = polyPoints[il].X - checkPoint.X;
                sy = polyPoints[il].Y - checkPoint.Y;
                ex = polyPoints[i].X - checkPoint.X;
                ey = polyPoints[i].Y - checkPoint.Y;
                if (sx == 0 && sy == 0)
                    return true;

                if (ex == 0 && ey == 0)
                    return true;

                // check if the line segment sx,sy - ex,ey straddles the X axis
                if (ey > 0 && sy <= 0)
                {
                    //calculate the intersection with the X axis
                    double ix = (ex * sy - sx * ey) / (double)(sy - ey);
                    //if this intersection is strictly +ve then we have a crossing
                    if (ix > 0)
                        crossings += 1;
                }

                if (sy > 0 && ey <= 0)
                {
                    //calculate the intersection with the X axis
                    double ix = (ex * sy - sx * ey) / (double)(sy - ey);
                    //if this intersection is strictly +ve then we have a crossing
                    if (ix > 0)
                        crossings += 1;
                }
            }

            //if there's an odd number of crossings then the point is in the poly
            if ((crossings % 2) == 1)
                isInPoly = true;
            else
                isInPoly = false;

            return isInPoly;
        }
        public static bool inPoly3(List<dataTypes.nrgVector3> polyPoints, double X, double Y)
        {
            bool isInPoly = false;
            int il = 0;
            int i = 0;
            // start and endpoints of a line seg
            double sx = 0;
            double sy = 0;
            double ex = 0;
            double ey = 0;
            int crossings = 0;

            int numLasso = polyPoints.Count;

            //if we have less than two points we don't have much of a polygon, so exit
            if (numLasso < 2)
                return false;

            crossings = 0;
            // go through each line segement in the polygon
            for (i = 0; i < numLasso; i++)
            {
                // get the start and end points of the line relative to origin X,Y
                il = i - 1;
                if (il == -1)
                    il = numLasso - 1;
                sx = polyPoints[il].X - X;
                sy = polyPoints[il].Y - Y;
                ex = polyPoints[i].X - X;
                ey = polyPoints[i].Y - Y;
                if (sx == 0 && sy == 0)
                    return true;

                if (ex == 0 && ey == 0)
                    return true;

                // check if the line segment sx,sy - ex,ey straddles the X axis
                if (ey > 0 && sy <= 0)
                {
                    //calculate the intersection with the X axis
                    double ix = (ex * sy - sx * ey) / (double)(sy - ey);
                    //if this intersection is strictly +ve then we have a crossing
                    if (ix > 0)
                        crossings += 1;
                }

                if (sy > 0 && ey <= 0)
                {
                    //calculate the intersection with the X axis
                    double ix = (ex * sy - sx * ey) / (double)(sy - ey);
                    //if this intersection is strictly +ve then we have a crossing
                    if (ix > 0)
                        crossings += 1;
                }
            }

            //if there's an odd number of crossings then the point is in the poly
            if ((crossings % 2) == 1)
                isInPoly = true;
            else
                isInPoly = false;

            return isInPoly;
        }

        public static bool inPoly3(List<dataTypes.nrgVector3> polyPoints, dataTypes.nrgVector3 checkPoint)
        {
            bool isInPoly = false;
            int il = 0;
            int i = 0;
            // start and endpoints of a line seg
            double sx = 0;
            double sy = 0;
            double ex = 0;
            double ey = 0;
            int crossings = 0;

            int numLasso = polyPoints.Count;

            //if we have less than two points we don't have much of a polygon, so exit
            if (numLasso < 2)
                return false;

            crossings = 0;
            // go through each line segement in the polygon
            for (i = 0; i < numLasso; i++)
            {
                // get the start and end points of the line relative to origin X,Y
                il = i - 1;
                if (il == -1)
                    il = numLasso - 1;
                sx = polyPoints[il].X - checkPoint.X;
                sy = polyPoints[il].Y - checkPoint.Y;
                ex = polyPoints[i].X - checkPoint.X;
                ey = polyPoints[i].Y - checkPoint.Y;
                if (sx == 0 && sy == 0)
                    return true;

                if (ex == 0 && ey == 0)
                    return true;

                // check if the line segment sx,sy - ex,ey straddles the X axis
                if (ey > 0 && sy <= 0)
                {
                    //calculate the intersection with the X axis
                    double ix = (ex * sy - sx * ey) / (double)(sy - ey);
                    //if this intersection is strictly +ve then we have a crossing
                    if (ix > 0)
                        crossings += 1;
                }

                if (sy > 0 && ey <= 0)
                {
                    //calculate the intersection with the X axis
                    double ix = (ex * sy - sx * ey) / (double)(sy - ey);
                    //if this intersection is strictly +ve then we have a crossing
                    if (ix > 0)
                        crossings += 1;
                }
            }

            //if there's an odd number of crossings then the point is in the poly
            if ((crossings % 2) == 1)
                isInPoly = true;
            else
                isInPoly = false;

            return isInPoly;
        }

      
        public static float colourByteToFloat(byte byte1, byte byte2, byte byte3, byte byte4)
        {
            byte[] vertVal = { byte1, byte2, byte3, byte4 };
            var inputNumber = BitConverter.ToInt32(vertVal, 0);
            float zround = ((float)inputNumber) / 10000f;
            return zround;
        }

        public static dataTypes.intVertex coordToPixel(dataTypes.nrgVector3 inputCoord, dataTypes.nrgVector3Bounds coordBounds, float scale)
        {

            var imageYcalc = (((coordBounds.maxY - coordBounds.minY) * scale));
            int X = (int)Math.Round(((inputCoord.X * scale) - (coordBounds.minX * scale)));
            int Y = (int)Math.Round((imageYcalc - ((inputCoord.Y * scale) - (coordBounds.minY * scale))));
            int Z = (int)Math.Round(((inputCoord.Z * scale) - (coordBounds.minZ * scale)));
            return new dataTypes.intVertex { X = X, Y = Y, Z = Z };
        }

        public static dataTypes.nrgVector3 pixeltoCoord(dataTypes.intVertex inputCoord, dataTypes.nrgVector3Bounds coordBounds, float scale)
        {

            var imageYcalc = (((coordBounds.maxY - coordBounds.minY) * scale));

            //int X = (int)Math.Round(((inputCoord.X * scale) - (coordBounds.minX * scale)));
            double X = (inputCoord.X + (coordBounds.minX * scale)) / scale;


            //int Y = (int)Math.Round((imageYcalc - ((inputCoord.Y * scale) - (coordBounds.minY * scale))));
            double Y = ((imageYcalc - inputCoord.Y) + (coordBounds.minY * scale)) / scale;


            //int Z = (int)Math.Round(((inputCoord.Z * scale) - (coordBounds.minZ * scale)));
            double Z = (inputCoord.Z + (coordBounds.minZ * scale)) / scale;

            return new dataTypes.nrgVector3 { X = X, Y = Y, Z = Z };
        }

        public static double map(double s, double a1, double a2, double b1, double b2)
        {
            return b1 + (s - a1) * (b2 - b1) / (a2 - a1);
        }

        public static byte[] colourFloatToByte(float inputNumber)
        {

            Int32 zround = (Int32)(inputNumber * 10000d);
            return BitConverter.GetBytes(zround);
        }

        public enum nrgFileTypes
        {
            nullLayer,
            GPFV2,
            XYZ,
            LAS,
            PDF,
            OBJ,
            MX
        }

        public enum HorizontalElementType
        {
            Straight,
            Arc,
            Spiral
        }

        public enum verticalElementType
        {
            Straight,
            Parabola
        }
        public enum triangleTypes
        {
            good,
            ok,
            prettyCrappy
        }


        public static double singlePointMultiplier = 10000;
        public static double nullPointValue = -100000000;

        public static void saveTransformationData(ref dataTypes.transformationData tData, string file)
        {

            StringBuilder output = new StringBuilder();
            output.AppendLine(";Transformation File V1");
            //Original Coords
            foreach (dataTypes.eastNorthTransform point in tData.pointList)
            {
                output.Append(point.x1);
                output.Append(",");
                output.Append(point.y1);
                output.Append(";");
            }
            output.Remove(output.Length - 1, 1);
            output.AppendLine("");
            //Transform Coords
            foreach (dataTypes.eastNorthTransform point in tData.pointList)
            {
                output.Append(point.x2);
                output.Append(",");
                output.Append(point.y2);
                output.Append(";");
            }
            output.Remove(output.Length - 1, 1);
            output.AppendLine("");

            output.AppendLine(tData.shiftX.ToString());
            output.AppendLine(tData.shiftY.ToString());
            output.AppendLine(tData.rotation.ToString());
            output.AppendLine(tData.scale.ToString());
            ;
           // helpers.saveStringToFile(output.ToString(), helpers.saveFileDialog("trn",file));
        }



      

        public static string removePrefix(string source, string searchChar)
        {
            bool isClean = false;
            string outString = source;
            while (!isClean)
            {
                string s = outString.Substring(0, 1);
                if (s.Equals(searchChar))
                {
                    outString = outString.Substring(1, outString.Length - 1);

                }
                else
                {

                    isClean = true;
                }
            }
            return outString;
        }

     

     

       

        public static Array ResizeArray(Array arr, int[] newSizes)
        {
            if (newSizes.Length != arr.Rank)
                throw new ArgumentException("arr must have the same number of dimensions " +
                                            "as there are elements in newSizes", "newSizes");

            var temp = Array.CreateInstance(arr.GetType().GetElementType(), newSizes);
            int length = arr.Length <= temp.Length ? arr.Length : temp.Length;
            Array.ConstrainedCopy(arr, 0, temp, 0, length);
            return temp;
        }

        public static int RGBtoInt(dataTypes.RGBColor inputColour)
        {


            //Create Empty Colour
            int colourOutput = 0;
            int r = inputColour.b;
            int g = inputColour.g;
            int b = inputColour.r;
            if (r < 0) r = 0;
            if (g < 0) g = 0;
            if (b < 0) b = 0;

            int rgb = r;
            rgb = (rgb << 8) + g;
            rgb = (rgb << 8) + b;
            colourOutput = rgb;


            return colourOutput;
        }

        
        //todo fix all this file stuff for android
        public static string loadFileDialog(string fileExtension,string path)
        {
            string fileName = "";

           

            return fileName;
        }

        public static string loadFileDialog(string fileExtension)
        {
            string fileName = "";

         

            return fileName;
        }

      

      

        public static string saveFileDialog(string fileExtension,string path)
        {
            string fileName = "NOFILE";


            return fileName;
        }

        public static void exportVolumeCSV(List<dataTypes.volumeReport> volumeList)
        {
            StringBuilder volString = new StringBuilder();
            volString.AppendLine("Surface ID,Surface Name,Cut Volume,Fil Volume");
            foreach (dataTypes.volumeReport currentVol in volumeList)
            {
                volString.AppendLine(currentVol.surfaceID + "," + currentVol.surfaceName + "," + currentVol.cutVolume + "," + currentVol.fillVolume);
            }

            string newFile = saveFileDialog("csv","");
            if (!newFile.Contains("NOFILE"))
            {
               
            }

        }
        public static void exportVector3ListToGPF(string filename, ref List<dataTypes.nrgVector3> pointList)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;
            foreach (dataTypes.nrgVector3 point in pointList)
            {
                pcString.AppendLine("Point " + pointIndex + ", PL," + point.X.ToString() + "," + point.Y.ToString() + "," + point.Z.ToString());
                pointIndex++;
            }
           

        }

        public static void exportVector3ListToGPF(ref List<dataTypes.nrgVector3> pointList)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;
            foreach (dataTypes.nrgVector3 point in pointList)
            {
                pcString.AppendLine("Point " + pointIndex + ", PL," + point.X.ToString() + "," + point.Y.ToString() + "," + point.Z.ToString());
                pointIndex++;
            }
            string newFile = saveFileDialog("gpf","");
            if (!newFile.Contains("NOFILE"))
            {
                
            }

        }

        public static void exportFullPointCloudGPF(string filename, ref List<dataTypes.pointCloudPoint> pcData)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;

            for (int i = 0; i < pcData.Count; i++)
            {
                string intCol = RGBtoInt(pcData[i].CodedColour).ToString();
                pcString.AppendLine("Point " + pointIndex + ", /RGB" + intCol + ", " + pcData[i].coord.X.ToString() + "," + pcData[i].coord.Y.ToString() + "," + pcData[i].coord.Z.ToString());
                pointIndex++;

            }
           


        }

        public static void exportFullPointCloudGPF(string filename, ref List<dataTypes.pointCloudPoint> pcData, string prefix)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;
            string pointPrefix = "";
            if (prefix.Length > 0)
            {
                pointPrefix = prefix + "/";
            }
            for (int i = 0; i < pcData.Count; i++)
            {
                string intCol = RGBtoInt(pcData[i].CodedColour).ToString();
                pcString.AppendLine("Point " + pointIndex + ", " + pointPrefix + "/RGB" + intCol + ", " + pcData[i].coord.X.ToString() + "," + pcData[i].coord.Y.ToString() + "," + pcData[i].coord.Z.ToString());
                pointIndex++;

            }
         


        }


      


        // ~7726420.gpf = gpffile

        public static bool fileExist(string filename)
        {

            return true;

        }

      

        public static void exportPointCloudListToGPF(string filename, ref List<dataTypes.pointCloudPoint> pcData)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;

            for (int i = 0; i < pcData.Count; i++)
            {
                string intCol = RGBtoInt(pcData[i].CodedColour).ToString();
                pcString.AppendLine("Point " + pointIndex + ", /RGB" + intCol + ", " + pcData[i].coord.X.ToString() + "," + pcData[i].coord.Y.ToString() + "," + pcData[i].coord.Z.ToString());
                pointIndex++;

            }
           

        }

        public static void exportPointCloudListToGPF(string filename, ref List<dataTypes.pointCloudPoint> pcData, string prefix)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;
            string pointPrefix = "";
            if (prefix.Length > 0)
            {
                pointPrefix = prefix + "/";
            }

            for (int i = 0; i < pcData.Count; i++)
            {
                string intCol = RGBtoInt(pcData[i].CodedColour).ToString();
                pcString.AppendLine("Point " + pointIndex + "," + pointPrefix + "/RGB" + intCol + ", " + pcData[i].coord.X.ToString() + "," + pcData[i].coord.Y.ToString() + "," + pcData[i].coord.Z.ToString());
                pointIndex++;

            }
           


        }

        public static void exportPointCloudListHeightMapToGPF(string filename, ref List<dataTypes.pointCloudPoint> pcData, ref dataTypes.pointCloud mainPC, string prefix)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;
            string pointPrefix = "";
            if (prefix.Length > 0)
            {
                pointPrefix = prefix + "/";
            }

            for (int i = 0; i < pcData.Count; i++)
            {
               // dataTypes.RGBColor newCol = heightToRGB(mainPC.doubleBounds.minZ, mainPC.doubleBounds.maxZ, pcData[i].coord.Z);

               // string intCol = RGBtoInt(newCol).ToString();
               // pcString.AppendLine("Point " + pointIndex + "," + pointPrefix + "/RGB" + intCol + ", " + pcData[i].coord.X.ToString() + "," + pcData[i].coord.Y.ToString() + "," + pcData[i].coord.Z.ToString());
                pointIndex++;

            }
           

        }

        public static void exportPointCloudListToGPF(string filename, ref dataTypes.pointCloud pcData, string prefix)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;

            string pointPrefix = "";
            if (prefix.Length > 0)
            {
                pointPrefix = prefix + "/";
            }

            for (int i = 0; i < pcData.outputPointIndexList.Count; i++)
            {
                if (pcData.outputPointIndexList[i] != -1)
                {
                    string intCol = RGBtoInt(pcData.points[pcData.outputPointIndexList[i]].CodedColour).ToString();
                    pcString.AppendLine("Point " + pointIndex + ", " + pointPrefix + "/RGB" + intCol + ", " + pcData.points[pcData.outputPointIndexList[i]].coord.X.ToString() + "," + pcData.points[pcData.outputPointIndexList[i]].coord.Y.ToString() + "," + pcData.points[pcData.outputPointIndexList[i]].coord.Z.ToString());
                }
                pointIndex++;

            }
          

        }

        public static void exportPointCloudListHeightMapToGPF(string filename, ref dataTypes.pointCloud pcData, string prefix)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;

            string pointPrefix = "";
            if (prefix.Length > 0)
            {
                pointPrefix = prefix + "/";
            }

            for (int i = 0; i < pcData.outputPointIndexList.Count; i++)
            {
                if (pcData.outputPointIndexList[i] != -1)
                {
                   // dataTypes.RGBColor newCol = heightToRGB(pcData.doubleBounds.minZ, pcData.doubleBounds.maxZ, pcData.points[pcData.outputPointIndexList[i]].coord.Z);

                   // string intCol = RGBtoInt(newCol).ToString();
                 //   pcString.AppendLine("Point " + pointIndex + ", " + pointPrefix + "/RGB" + intCol + ", " + pcData.points[pcData.outputPointIndexList[i]].coord.X.ToString() + "," + pcData.points[pcData.outputPointIndexList[i]].coord.Y.ToString() + "," + pcData.points[pcData.outputPointIndexList[i]].coord.Z.ToString());
                }
                pointIndex++;

            }
          


        }

        public static void exportPointCloudListToGPF(string filename, ref dataTypes.pointCloud pcData)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;

            for (int i = 0; i < pcData.outputPointIndexList.Count; i++)
            {
                if (pcData.outputPointIndexList[i] != -1)
                {
                    string intCol = RGBtoInt(pcData.points[pcData.outputPointIndexList[i]].CodedColour).ToString();
                    pcString.AppendLine("Point " + pointIndex + ", /RGB" + intCol + ", " + pcData.points[pcData.outputPointIndexList[i]].coord.X.ToString() + "," + pcData.points[pcData.outputPointIndexList[i]].coord.Y.ToString() + "," + pcData.points[pcData.outputPointIndexList[i]].coord.Z.ToString());
                }
                pointIndex++;

            }
          


        }

        public static void exportPointIndexListToGPF(string filename, ref dataTypes.pointCloud pcData)
        {
            StringBuilder pcString = new StringBuilder();
            pcString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");
            int pointIndex = 0;
            foreach (dataTypes.pointCloudPoint point in pcData.points)
            {
                string intCol = RGBtoInt(point.CodedColour).ToString();
                pcString.AppendLine("Point " + pointIndex + ", /RGB" + intCol + ", " + point.coord.X.ToString() + "," + point.coord.Y.ToString() + "," + point.coord.Z.ToString());
                pointIndex++;
            }
          

        }

        public static void exportPointCloudGridToGPF(double[,] inputListX, double[,] inputListY, double[,] inputListZ)
        {
            StringBuilder volString = new StringBuilder();
            volString.AppendLine(";NRG GROUND PLOT FILE VERSION 2");

            for (int xPos = 0; xPos < inputListZ.GetLength(0); xPos++)
            {
                for (int yPos = 0; yPos < inputListZ.GetLength(1); yPos++)
                {
                    if (inputListZ[xPos, yPos] != 0)
                    {

                        volString.AppendLine(xPos + yPos + ",PL," + inputListX[xPos, yPos].ToString() + "," + inputListY[xPos, yPos].ToString() + "," + inputListZ[xPos, yPos].ToString());
                    }
                }
            }

            string newFile = saveFileDialog("gpf","");
            if (!newFile.Contains("NOFILE"))
            {
              
            }

        }
        public static void ConvertLongArrayIndex(Int32 LongIndex, Int16 increment, ref Int16 firstDim, ref Int16 secondDim)
        {

            firstDim = 0;
            secondDim = 0;
            float f;
            float s;

            if ((LongIndex < increment) && (LongIndex > -1))
            {
                firstDim = (Int16)LongIndex;
                secondDim = 0;
            }
            else
            {
                s = LongIndex / increment;
                if (LongIndex < 0)
                {
                    secondDim--;
                }
                else
                {
                    secondDim = (Int16)(s);
                }
                f = LongIndex - secondDim * increment;
                firstDim = (Int16)(f);
            }
        }


        public static double get3DLengthBetweenXYZ(dataTypes.nrgVector3 pt1, dataTypes.nrgVector3 pt2)
        {
            double outputLength = 0d;
            outputLength = Math.Sqrt(Math.Pow(pt2.Z - pt1.Z, 2) + Math.Pow(pt2.X - pt1.X, 2) + Math.Pow(pt2.Y - pt1.Y, 2));
            return outputLength;
        }
        public static double get2DLengthBetweenXYZ(dataTypes.nrgVector3 pt1, dataTypes.nrgVector3 pt2)
        {
            double outputLength = 0d;
            outputLength = Math.Sqrt(Math.Pow(pt2.X - pt1.X, 2) + Math.Pow(pt2.Y - pt1.Y, 2));
            return outputLength;
        }
        public static double get2DLengthBetweenVector3andXYZ(dataTypes.nrgVector3 pt1, dataTypes.nrgVector3 pt2)
        {
            double outputLength = 0d;
            outputLength = Math.Sqrt(Math.Pow(pt2.X - pt1.X, 2) + Math.Pow(pt2.Y - pt1.Y, 2));
            return outputLength;
        }
        public static double get3DLengthBetweenVertex(dataTypes.nrgVertex pt1, dataTypes.nrgVertex pt2)
        {
            double outputLength = 0d;
            outputLength = Math.Sqrt(Math.Pow(pt2.Z - pt1.Z, 2) + Math.Pow(pt2.X - pt1.X, 2) + Math.Pow(pt2.Y - pt1.Y, 2));
            return outputLength;
        }

        public static double FNAngle(double a, double b)
        {
            double answer = 0, TWOPI = Math.PI * 2;
            answer = a - b;
           if (answer > TWOPI) { answer = answer - TWOPI; }
           if (answer < 0) { answer = answer + TWOPI; }

           // answer = ((answer / TWOPI) - (int)((double)((answer / TWOPI)))) * TWOPI;

            return answer;
        }

        public static double FnSmallAngle(double A, double b)
        {
            double answer = 0, TWOPI = Math.PI * 2;

            answer = A - b;
            if (answer > TWOPI) { answer = answer - TWOPI; }
            if (answer < 0) { answer = answer + TWOPI; }
            if (answer > Math.PI) { answer = TWOPI - answer; }
            return answer;
        }

        public static dataTypes.nrgVector3 rotateXYClockWiseAroundOrigin (double x, double y, double clockWiseAngle, double originX, double originY){
            dataTypes.nrgVector3 outputPoint = new dataTypes.nrgVector3();

            outputPoint.X = originX + (Math.Cos(clockWiseAngle) * (x - originX)) + (Math.Sin(clockWiseAngle) * (y - originY));
            outputPoint.Y = originY - (Math.Sin(clockWiseAngle) * (x - originX)) + (Math.Cos(clockWiseAngle) * (y - originY));

            return outputPoint;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="Eocc"></param>
        /// <param name="Nocc"></param>
        /// <param name="er"></param>
        /// <param name="nr"></param> 
        public static double RPC(double Eocc, double Nocc, double er, double nr)
        {
            double scaleFactor = 1;
            double X, Y;
            double brg = 0;
            if (scaleFactor <= 0) { scaleFactor = 1; }

            X = er - Eocc;
            Y = nr - Nocc;

            bool calcBrg = true;

            if (Y == 0 & X >= 0)
            {
                brg = Math.PI / 2;
                calcBrg = false;
            }
            if (Y == 0 & X < 0)
            {
                brg = 1.5 * Math.PI;
                calcBrg = false;
            }

            if (calcBrg == true)
            {
                brg = Math.Atan(X / Y) - Math.PI;
                if (Y > 0) { brg = brg + Math.PI; }
                if (brg < 0) { brg = brg + (2 * Math.PI); }
            }

            return brg;
        }

        public static void RPC(double Eocc, double Nocc, double er, double nr, ref double brg, ref double dist, double scaleFactor)
        {

            double X, Y;

            if (scaleFactor <= 0) { scaleFactor = 1; }

            X = er - Eocc;
            Y = nr - Nocc;

            bool calcBrg = true;

            if (Y == 0 & X >= 0)
            {
                brg = Math.PI / 2;
                calcBrg = false;
            }
            if (Y == 0 & X < 0)
            {
                brg = 1.5 * Math.PI;
                calcBrg = false;
            }

            if (calcBrg == true)
            {
                brg = Math.Atan(X / Y) - Math.PI;
                if (Y > 0) { brg = brg + Math.PI; }
                if (brg < 0) { brg = brg + (2 * Math.PI); }
            }

            dist = Math.Sqrt((X * X) + (Y * Y));
            dist = dist / scaleFactor;
        }
        public static double FNInterpolateY(double X1, double Y1, double X2, double Y2, double X3)
        {
            double output;
            double DistBetween1and2, DistBetween1and3, HeightDiffBetween1and2;

            DistBetween1and2 = X2 - X1;
            DistBetween1and3 = X3 - X1;
            HeightDiffBetween1and2 = Y2 - Y1;

            if (DistBetween1and2 == 0)
                return output = (Y1 + Y2) / 2;
            else
                output = Y1 + HeightDiffBetween1and2 * DistBetween1and3 / DistBetween1and2;

            return output;

        }
        public static bool FNEquals(double A, double b)
        {
            //check if two numbers are equal to within 0.001
            return (Math.Abs(A - b) < 0.001);
        }
        public static bool FNEquals2(double A, double b, double tol)
        {
            return (Math.Abs(A - b) < tol);
        }

        public static void distanceAndOffsetFromLine(double originX, double originY, double bearing, double px, double py, ref double distance, ref double offset)
        {

            double brg=0;
            double dist=0;
            double theta=0;

            RPC(originX, originY, px, py, ref brg, ref dist, 1);
            if (FNDistance(originX, originY, px, py) <= 0.001)
            {
                distance = 0;
                offset = 0;
                return;
            }

            theta = brg - bearing;
            distance = Math.Cos(theta) * dist;
            offset = Math.Sin(theta) * dist;

        }

        public static dataTypes.nrgVector2 PRC(double east, double north, double brg, double dist, double scalefactor)
        {
            double newdist = 0, nX = 0, nY = 0;
            if (scalefactor == 0) { scalefactor = 1; }

            newdist = dist * scalefactor;
            if (brg == Math.PI / 2)
            {
                nX = newdist;
            }
            else if (brg == 3 * (Math.PI / 2))
            {
                nX = -newdist;
            }
            else
            {
                nX = Math.Sin(brg) * newdist;
            }
            if (brg == 0)
            {
                nY = newdist;
            }
            else if (brg == Math.PI)
            {
                nY = -newdist;
            }
            else
            {
                nY = Math.Cos(brg) * newdist;
            }
            return new dataTypes.nrgVector2 { X = east + nX, Y = north + nY };
           
        }

        public static void PRC(double east, double north, double brg, double dist, ref double easta, ref double northa, double scalefactor)
        {
            double newdist = 0, X = 0, Y = 0;
            if (scalefactor == 0) { scalefactor = 1; }

            newdist = dist * scalefactor;
            if (brg == Math.PI / 2)
            {
                X = newdist;
            }
            else if (brg == 3 * (Math.PI / 2))
            {
                X = -newdist;
            }
            else
            {
                X = Math.Sin(brg) * newdist;
            }
            if (brg == 0)
            {
                Y = newdist;
            }
            else if (brg == Math.PI)
            {
                Y = -newdist;
            }
            else
            {
                Y = Math.Cos(brg) * newdist;
            }
            easta = east + X;
            northa = north + Y;
        }

        public static int findnearestPoint(dataTypes.nrgPoint searchPoint, List<dataTypes.nrgPoint> pointsList, double distanceTolerance = 1)
        {
            double currentDistance = 9999999999999;
            double distance = 9999999999;
            int foundPointIndex = 0;
            int pointIndex = 0;
            foreach (dataTypes.nrgPoint point in pointsList)
            {

                double a = (double)(searchPoint.coord.X - point.coord.X);
                double b = (double)(searchPoint.coord.Y - point.coord.Y);
                currentDistance = Math.Sqrt(a * a + b * b);

                if ((currentDistance < distance))
                {
                    distance = currentDistance;
                    foundPointIndex = pointIndex;
                }
                pointIndex++;
            }
            return foundPointIndex;

        }
        public static double GetBearing(double lat1, double lon1, double lat2, double lon2)
        {
            double dx = lat2 - lat1;
            double dy = lon2 - lon1;
            return Math.Atan2(dy, dx) * (180 / Math.PI);
        }
        public static double rectangularToPolarCoord(double Eocc, double Nocc, double er, double nr)
        {
            double dist = 0; double brg = 0;
            double X, Y;
            X = er - Eocc;
            Y = nr - Nocc;
            if (Y == 0 & X >= 0)
                brg = Math.PI / 2;
            else if (Y == 0 & X < 0)
                brg = 1.5 * Math.PI;
            else
            {
                brg = Math.Atan(X / Y) - Math.PI;
                if (Y > 0) brg = brg + Math.PI;
                if (brg < 0) brg = brg + (2 * Math.PI);
            }
            dist = Math.Sqrt((Math.Pow(X, 2)) + (Math.Pow(Y, 2)));

            return brg;
        }
        public static double getLevelFromLineKnownPoints(dataTypes.nrgVertex pt1, dataTypes.nrgVertex pt2, dataTypes.nrgVector3 targetPoint)
        {


            double newLevel = 0d;
            var vector = new dataTypes.nrgVector3 { X = pt2.X - pt1.X, Y = pt2.Y - pt1.Y, Z = pt2.Z - pt1.Z };
            var partVector = new dataTypes.nrgVector3 { X = targetPoint.X - pt1.X, Y = targetPoint.Y - pt1.Y, Z = 0d };

            var xL = Math.Sqrt((vector.X * vector.X) + (vector.Y * vector.Y) + (vector.Z * vector.Z));
            var yL = Math.Sqrt((vector.X * vector.X) + (vector.Y * vector.Y) + (vector.Z * vector.Z));
            var zL = Math.Sqrt((vector.X * vector.X) + (vector.Y * vector.Y) + (vector.Z * vector.Z));

            var length = get3DLengthBetweenVertex(pt1, pt2);

            var nX = vector.X / xL;
            var nY = vector.Y / yL;
            var nZ = vector.Z / zL;
            var vectorNormalised = new dataTypes.nrgVector3 { X = nX, Y = nY, Z = nZ };


            var pnX = partVector.X / xL;
            var pnY = partVector.Y / yL;
            var pnZ = 0d;

            var partVectorNormalised = new dataTypes.nrgVector3 { X = pnX, Y = pnY, Z = pnZ };


            var ratio = ((pnX / nX) + (pnY / nY)) / 2;


            var zVec = ratio * nZ * (length);
            newLevel = pt1.Z - (zVec * Math.Sign(vector.Z));

            return newLevel;
        }


        public static double sign(dataTypes.nrgVector3 p1, dataTypes.nrgVector3 p2, dataTypes.nrgVector3 p3)
        {
            return (p1.X - p3.X) * (p2.Y - p3.Y) - (p2.X - p3.X) * (p1.Y - p3.Y);
        }
        public static double calcLevelOnPlane(dataTypes.nrgVector3 p, dataTypes.nrgVertex p0, dataTypes.nrgVertex p1, dataTypes.nrgVertex p2)
        {
            double a1, a2, b1, b2, C1, c2, Az, bz, cz;
            a1 = p.X - p0.X;
            a2 = p.Y - p0.Y;
            b1 = p.X - p1.X;
            b2 = p.Y - p1.Y;
            C1 = p.X - p2.X;
            c2 = p.Y - p2.Y;
            Az = p0.Z;
            bz = p1.Z;
            cz = p2.Z;
            return ((a1 * b2 * cz) - (a1 * bz * c2) + (a2 * bz * C1) - (a2 * b1 * cz) + (Az * b1 * c2) - (Az * b2 * C1)) / ((a1 * b2) - (a1 * c2) + (a2 * C1) - (a2 * b1) + (b1 * c2) - (b2 * C1));
        }
        public static int getNextTriByEdgeIntersection(dataTypes.nrgVector3 sourcePoint, dataTypes.nrgVector3 targetPoint, ref dataTypes.nrgTriangle[] triangles, ref dataTypes.nrgVertex[] vertices, int targetTriangle, int currentTriangle, int lastTriangle, ref dataTypes.nrgVector3 intersectionPoint, double brg)
        {
            int nextTriangle = -1;
            bool foundEdge = false;



            double lineBearing1 = Math.Round(GetBearing(intersectionPoint.X, intersectionPoint.Y, sourcePoint.X, sourcePoint.Y), 7);
            double lineBearing2 = Math.Round(GetBearing(intersectionPoint.X, intersectionPoint.Y, sourcePoint.X, sourcePoint.Y), 7);
            double lineBearing3 = Math.Round(GetBearing(intersectionPoint.X, intersectionPoint.Y, sourcePoint.X, sourcePoint.Y), 7);


            var intersection1 = IntersectTwoBrgLines(
                      sourcePoint.X, sourcePoint.Y,
                      rectangularToPolarCoord(sourcePoint.X, sourcePoint.Y, targetPoint.X, targetPoint.Y),
                      vertices[triangles[currentTriangle].P0].X, vertices[triangles[currentTriangle].P0].Y,
                      rectangularToPolarCoord(vertices[triangles[currentTriangle].P0].X, vertices[triangles[currentTriangle].P0].Y, vertices[triangles[currentTriangle].P1].X, vertices[triangles[currentTriangle].P1].Y)
                      );
            var intersection2 = IntersectTwoBrgLines(
                sourcePoint.X, sourcePoint.Y,
                rectangularToPolarCoord(sourcePoint.X, sourcePoint.Y, targetPoint.X, targetPoint.Y),
                vertices[triangles[currentTriangle].P1].X, vertices[triangles[currentTriangle].P1].Y,
                rectangularToPolarCoord(vertices[triangles[currentTriangle].P1].X, vertices[triangles[currentTriangle].P1].Y, vertices[triangles[currentTriangle].P2].X, vertices[triangles[currentTriangle].P2].Y)
                );
            var intersection3 = IntersectTwoBrgLines(
                sourcePoint.X, sourcePoint.Y,
                rectangularToPolarCoord(sourcePoint.X, sourcePoint.Y, targetPoint.X, targetPoint.Y),
                vertices[triangles[currentTriangle].P2].X, vertices[triangles[currentTriangle].P2].Y,
                rectangularToPolarCoord(vertices[triangles[currentTriangle].P2].X, vertices[triangles[currentTriangle].P2].Y, vertices[triangles[currentTriangle].P0].X, vertices[triangles[currentTriangle].P0].Y)
                );

            double newBearing1 = Math.Round(rectangularToPolarCoord(intersectionPoint.X, intersectionPoint.Y, intersection1.X, intersection1.Y), 7);
            double newBearing2 = Math.Round(rectangularToPolarCoord(intersectionPoint.X, intersectionPoint.Y, intersection2.X, intersection2.Y), 7);
            double newBearing3 = Math.Round(rectangularToPolarCoord(intersectionPoint.X, intersectionPoint.Y, intersection3.X, intersection3.Y), 7);

            var lastIntersectionPoint = intersectionPoint;


            bool intersection1InSectionBox = functionInBox2(sourcePoint.X, sourcePoint.Y, targetPoint.X, targetPoint.Y, intersection1.X, intersection1.Y, 0);
            bool intersection1InEdgeBox = functionInBox2(vertices[triangles[currentTriangle].P0].X, vertices[triangles[currentTriangle].P0].Y, vertices[triangles[currentTriangle].P1].X, vertices[triangles[currentTriangle].P1].Y, intersection1.X, intersection1.Y, 0);
            if (!foundEdge)
            {
                if (intersection1.X != nullPointValue)
                    if (brg == newBearing1 && intersection1InSectionBox && intersection1InEdgeBox)
                    {
                        if (triangles[currentTriangle].N0 == lastTriangle)
                        {
                            foundEdge = false;
                        }
                        else
                        {

                            foundEdge = true;
                            nextTriangle = triangles[currentTriangle].N0;
                            var newZ = calcLevelOnPlane(new dataTypes.nrgVector3 { X = intersection1.X, Y = intersection1.Y, Z = 0 }, vertices[triangles[currentTriangle].P0], vertices[triangles[currentTriangle].P1], vertices[triangles[currentTriangle].P2]);
                            intersectionPoint = new dataTypes.nrgVector3 { X = intersection1.X, Y = intersection1.Y, Z = newZ };
                            Debug.WriteLine("This one! 1:" + intersection1.X + "," + intersection1.Y + "," + intersection1.Z + "," + newBearing1 + "," + intersection1InSectionBox + "," + intersection1InEdgeBox + "," + nextTriangle);
                        }
                    }
            }

            bool intersection2InSectionBox = functionInBox2(sourcePoint.X, sourcePoint.Y, targetPoint.X, targetPoint.Y, intersection2.X, intersection2.Y, 0);
            bool intersection2InEdgeBox = functionInBox2(vertices[triangles[currentTriangle].P1].X, vertices[triangles[currentTriangle].P1].Y, vertices[triangles[currentTriangle].P2].X, vertices[triangles[currentTriangle].P2].Y, intersection2.X, intersection2.Y, 0);
            if (!foundEdge)
            {
                if (intersection2.X != nullPointValue)
                    if (brg == newBearing2 && intersection2InSectionBox && intersection2InEdgeBox)
                    {
                        if (triangles[currentTriangle].N1 == lastTriangle)
                        {
                            foundEdge = false;
                        }
                        else
                        {
                            foundEdge = true;
                            nextTriangle = triangles[currentTriangle].N1;
                            var newZ = calcLevelOnPlane(new dataTypes.nrgVector3 { X = intersection2.X, Y = intersection2.Y, Z = 0 }, vertices[triangles[currentTriangle].P0], vertices[triangles[currentTriangle].P1], vertices[triangles[currentTriangle].P2]);
                            //var newZ = getLevelFromLineKnownPoints(vertices[triangles[currentTriangle].P1], vertices[triangles[currentTriangle].P2], new nrgDataTypes.nrgVector3 { X = intersection2.X, Y = intersection2.Y, Z = 0f });
                            intersectionPoint = new dataTypes.nrgVector3 { X = intersection2.X, Y = intersection2.Y, Z = newZ };
                            Debug.WriteLine("This one! 2:" + intersection2.X + "," + intersection2.Y + "," + intersection2.Z + "," + newBearing2 + "," + intersection2InSectionBox + "," + intersection2InEdgeBox + "," + nextTriangle);
                        }

                    }

            }

            bool intersection3InSectionBox = functionInBox2(sourcePoint.X, sourcePoint.Y, targetPoint.X, targetPoint.Y, intersection3.X, intersection3.Y, 0);
            bool intersection3InEdgeBox = functionInBox2(vertices[triangles[currentTriangle].P2].X, vertices[triangles[currentTriangle].P2].Y, vertices[triangles[currentTriangle].P0].X, vertices[triangles[currentTriangle].P0].Y, intersection3.X, intersection3.Y, 0);
            if (!foundEdge)
            {
                if (intersection3.X != nullPointValue)
                    if (brg == newBearing3 && intersection3InSectionBox && intersection3InEdgeBox)
                    {
                        if (triangles[currentTriangle].N2 == lastTriangle)
                        {
                            foundEdge = false;
                        }
                        else
                        {
                            foundEdge = true;
                            nextTriangle = triangles[currentTriangle].N2;
                            var newZ = calcLevelOnPlane(new dataTypes.nrgVector3 { X = intersection3.X, Y = intersection3.Y, Z = 0 }, vertices[triangles[currentTriangle].P0], vertices[triangles[currentTriangle].P1], vertices[triangles[currentTriangle].P2]);
                            //var newZ = getLevelFromLineKnownPoints(vertices[triangles[currentTriangle].P2], vertices[triangles[currentTriangle].P0], new nrgDataTypes.nrgVector3 { X = intersection3.X, Y = intersection3.Y, Z = 0f });
                            intersectionPoint = new dataTypes.nrgVector3 { X = intersection3.X, Y = intersection3.Y, Z = newZ };
                            Debug.WriteLine("This one! 3:" + intersection3.X + "," + intersection3.Y + "," + intersection3.Z + "," + newBearing3 + "," + intersection3InSectionBox + "," + intersection3InEdgeBox + "," + nextTriangle);
                        }
                    }

            }

            return nextTriangle;
        }
        public static dataTypes.nrgVector3 LineIntersectionPoint(dataTypes.nrgVector3 ps1, dataTypes.nrgVector3 pe1, dataTypes.nrgVertex ps2, dataTypes.nrgVertex pe2, double tol)
        {
            var outputPoint = new dataTypes.nrgVector3 { X = nullPointValue, Y = nullPointValue, Z = nullPointValue };

            // Get A,B,C of first line - points : ps1 to pe1
            double A1 = pe1.Y - ps1.Y;
            double B1 = ps1.X - pe1.X;
            double C1 = A1 * ps1.X + B1 * ps1.Y;

            // Get A,B,C of second line - points : ps2 to pe2
            double A2 = pe2.Y - ps2.Y;
            double B2 = ps2.X - pe2.X;
            double C2 = A2 * ps2.X + B2 * ps2.Y;

            // Get delta and check if the lines are parallel
            double delta = A1 * B2 - A2 * B1;
            if (delta < tol)
            {
                return new dataTypes.nrgVector3
                {
                    X = nullPointValue,
                    Y = nullPointValue,
                    Z = nullPointValue
                };

            }
            // now return the Vector2 intersection point
            return new dataTypes.nrgVector3
            {
                X = (B2 * C1 - B1 * C2) / delta,
                Y = (A1 * C2 - A2 * C1) / delta,
                Z = 0D
            };

        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="Eocc"></param>
        /// <param name="Nocc"></param>
        /// <param name="brg"></param>
        /// <param name="Eocc2"></param> 
        /// <param name="Nocc2"></param> 
        /// <param name="brg2"></param>
        public static dataTypes.nrgVector3 IntersectTwoBrgLines(double Eocc, double Nocc, double brg, double Eocc2, double Nocc2, double brg2)
        {
            double X = nullPointValue;
            double Y = nullPointValue;
            double IpX = nullPointValue;
            double IpY = nullPointValue;

            if (FNEquals2(brg, Math.PI / 2, 0.00000000001) || FNEquals2(brg, Math.PI * 1.5, 0.00000000001))
            {
                if (FNEquals2(brg2, Math.PI / 2, 0.00000000001) || FNEquals2(brg2, Math.PI * 1.5, 0.00000000001))
                {
                    //MEh
                }
                else
                {
                    IpY = Nocc;
                    Y = Nocc2 - Nocc;
                    X = Y * Math.Tan(brg2);
                    IpX = Eocc2 - X;
                }
            }
            else if (FNEquals2(brg2, Math.PI / 2, 0.00000000001) || FNEquals2(brg2, Math.PI * 1.5, 0.00000000001))
            {
                if (FNEquals2(brg, Math.PI / 2, 0.00000000001) || FNEquals2(brg, Math.PI * 1.5, 0.00000000001))
                {

                }
                else
                {
                    IpY = Nocc2;
                    Y = Nocc - Nocc2;
                    X = Y * Math.Tan(brg);
                    IpX = Eocc - X;
                }
            }
            else if (Math.Abs(Math.Tan(brg) - Math.Tan(brg2)) < 0.000000000000001)
            {

            }
            else
            {
                Y = (Eocc2 - Eocc) - ((Nocc2 - Nocc) * Math.Tan(brg2));
                Y = Y / (Math.Tan(brg) - Math.Tan(brg2));
                X = Y * Math.Tan(brg);
                if (Math.Abs(X) > 100000 || Math.Abs(Y) > 100000)
                {

                }
                else
                {
                    IpX = X + Eocc;
                    IpY = Y + Nocc;
                }
            }

            return new dataTypes.nrgVector3 { X = IpX, Y = IpY, Z = 0f };

        }
        public static dataTypes.nrgVector3 Intersect3DLines(double X1, double Y1, double Z1, double X2, double Y2, double Z2, double X3, double Y3, double Z3, double X4, double Y4, double z4, bool IPWithinLimits = true)
        {
            double IpX = 0d;
            double IpY = 0d;
            double IpZ = 0d;


            double ux, uY, uz = 0d;
            double vx = 0d, vy = 0d, vz = 0d;
            double wx = 0d, wy = 0d, wZ = 0d;
            double A = 0d, b = 0d, c = 0d, d = 0d, e = 0d;
            double dt = 0d, sc = 0d, TC = 0d;
            double dx = 0d, dy = 0d, dz = 0d;


            ux = X2 - X1; uY = Y2 - Y1; uz = Z2 - Z1;
            vx = X4 - X3; vy = Y4 - Y3; vz = z4 - Z3;
            wx = X1 - X3; wy = Y1 - Y3; wZ = Z1 - Z3;

            A = (ux * ux + uY * uY + uz * uz);
            b = (ux * vx + uY * vy + uz * vz);
            c = (vx * vx + vy * vy + vz * vz);
            d = (ux * wx + uY * wy + uz * wZ);
            e = (vx * wx + vy * wy + vz * wZ);
            dt = A * c - b * b;


            if (FNEquals(dt, 0d))
            {
                if (b > c)
                    TC = d / b;
                else
                    TC = e / c;
            }
            else
            {
                sc = (b * e - c * d) / dt;
                TC = (A * e - b * d) / dt;
            }

            dx = wx + (sc * ux) - (TC * vx);
            dy = wy + (sc * uY) - (TC * vy);
            dz = wZ + (sc * uz) - (TC * vz);

            if (((dx * dx + dy * dy + dz * dz) <= 0.001))
            {
                //Intersect3dLines = true; Found line
                IpX = ((X1 + (sc * ux)) + (X3 + (TC * vx))) * 0.5;
                IpY = ((Y1 + (sc * uY)) + (Y3 + (TC * vy))) * 0.5;
                IpZ = ((Z1 + (sc * uz)) + (Z3 + (TC * vz))) * 0.5;


                if (IPWithinLimits)
                {
                    var isInLimits = (FNDistance(X1, Y1, IpX, IpY) <= FNDistance(X1, Y1, X2, Y2)) && (FNDistance(X2, Y2, IpX, IpY) <= FNDistance(X1, Y1, X2, Y2));
                    if (!isInLimits)
                    {
                        IpX = nullPointValue;
                        IpY = nullPointValue;
                        IpZ = nullPointValue;
                    }
                }
            }
            else
            {
                // Intersect3dLines = False
                IpX = nullPointValue;
                IpY = nullPointValue;
                IpZ = nullPointValue;
            }

            return new dataTypes.nrgVector3 { X = IpX, Y = IpY, Z = IpZ };

        }


        public static double FNDistance(double x1, double y1, double x2, double y2)
        {
            var a = (double)(x2 - x1);
            var b = (double)(y2 - y1);

            return Math.Sqrt(a * a + b * b);

        }
        public static double calcTriPlanAreaDirect(double p0x, double p0y, double p1x, double p1y, double p2x, double p2y)
        {
            return (((p1x - p0x) * (p1y + p0y)) + ((p2x - p1x) * (p2y + p1y)) + ((p0x - p2x) * (p0y + p2y))) / 2;
        }
        public static double calcTriPlanAreaDirect2(double p0x, double p0y, double p1x, double p1y, double p2x, double p2y)
        {

            double a = Math.Sqrt(Math.Pow(p1x - p0x, 2) + Math.Pow(p1y - p0y, 2));
            double b = Math.Sqrt(Math.Pow(p2x - p1x, 2) + Math.Pow(p2y - p1y, 2));
            double c = Math.Sqrt(Math.Pow(p0x - p2x, 2) + Math.Pow(p0y - p2y, 2));
            double s = (a + b + c) / 2d;
            return Math.Sqrt((s * (s - a) * (s - b) * (s - c)));
        }
        public static double CalcTriSurfaceArea(dataTypes.nrgVector3 p0, dataTypes.nrgVector3 p1, dataTypes.nrgVector3 p2)
        {
            double A, b, c, s;
            A = Math.Sqrt((p0.X - p1.X) * (p0.X - p1.X) + (p0.Y - p1.Y) * (p0.Y - p1.Y) + (p0.Z - p1.Z) * (p0.Z - p1.Z));
            b = Math.Sqrt((p1.X - p2.X) * (p1.X - p2.X) + (p1.Y - p2.Y) * (p1.Y - p2.Y) + (p1.Z - p2.Z) * (p1.Z - p2.Z));
            c = Math.Sqrt((p2.X - p0.X) * (p2.X - p0.X) + (p2.Y - p0.Y) * (p2.Y - p0.Y) + (p2.Z - p0.Z) * (p2.Z - p0.Z));
            s = (A + b + c) / 2d;
            return Math.Sqrt(Math.Abs(s * (s - A) * (s - b) * (s - c)));

        }
        public static Int16 functionOnLine3(double X1, double Y1, double X2, double Y2, double X, double Y, double tol)
        {
            try
            {
                double Diff = (X - X1) * (Y2 - Y) - (Y - Y1) * (X2 - X);
                if (Math.Abs(Diff) < (tol * tol))
                    return 0;
                else
                    return (Int16)Math.Sign(Diff);
            }
            catch
            { 
                return 0;
            }
            
        }
        public static bool functionInBox3(double fx1, double fy1, double fx2, double fy2, double fx3, double fy3, double fx4, double fy4, double iX, double iY)
        {
            double left1, left2, left3, left4;
            left1 = functionOnLine3(fx1, fy1, fx2, fy2, iX, iY, 0.0001);
            left2 = functionOnLine3(fx2, fy2, fx3, fy3, iX, iY, 0.0001);
            left3 = functionOnLine3(fx3, fy3, fx4, fy4, iX, iY, 0.0001);
            left4 = functionOnLine3(fx4, fy4, fx1, fy1, iX, iY, 0.0001);
            if (Math.Abs(left1 + left2 + left3 + left4) == 4)
                return true;
            else
                return false;
        }

        public static bool functionInBoxX(double fx1, double fy1, double fx2, double fy2, double iX, double iY)
        {
            return ((iX > fx1) && (iX < fx2) && (iY > fy1) && (iY < fy2));
        }

        /// <summary>
        /// Checks to see if a given intersection exists within a line segment
        /// </summary>
        /// <param name="fx1">Easting of start of segement</param>
        /// <param name="fy1">Northing of start of segment</param>
        /// <param name="fx2">Easting of start of segment</param>
        /// <param name="fy2">Northing of start of segment</param>
        /// <param name="iX">Easting of intersection</param>
        /// <param name="iY">Northing of intersection</param>
        /// <returns>True if intersection exists within the line segment</returns>
        public static bool functionInBox1(double fx1, double fy1, double fx2, double fy2, double iX, double iY)
        {
            bool isInBox = false;
            double Right1;
            double left1;
            double top1;
            double bot1;

            if (fx1 > fx2)
            {
                Right1 = fx1;
                left1 = fx2;
            }
            else
            {
                Right1 = fx2;
                left1 = fx1;
            }

            if (fy1 > fy2)
            {
                top1 = fy1;
                bot1 = fy2;
            }
            else
            {
                top1 = fy2;
                bot1 = fy1;
            }
            isInBox = ((iX >= left1 - 0.0009d && iX <= Right1 + 0.0009d) && (iY >= bot1 - 0.0009d && iY <= top1 + 0.0009d));


            return isInBox;
        }
        public static bool functionInBox2(double fx1, double fy1, double fx2, double fy2, double iX, double iY, double tol)
        {
            bool isInBox = false;
            double Right1;
            double left1;
            double top1;
            double bot1;
            tol = Math.Abs(tol);

            if (fx1 > fx2)
            {
                Right1 = fx1;
                left1 = fx2;
            }
            else
            {
                Right1 = fx2;
                left1 = fx1;
            }

            if (fy1 > fy2)
            {
                top1 = fy1;
                bot1 = fy2;
            }
            else
            {
                top1 = fy2;
                bot1 = fy1;
            }
            isInBox = ((iX >= left1 - tol && iX <= Right1 + tol) && (iY >= bot1 - tol && iY <= top1 + tol));


            return isInBox;
        }
        public static double getXFromVert(ref dataTypes.nrgTriangle triangle, ref dataTypes.nrgVertex[] vertices, int node)
        {

            if (node == 1)
                return vertices[triangle.P0].X;
            else if (node == 2)
                return vertices[triangle.P1].X;
            else if (node == 3)
                return vertices[triangle.P2].X;
            else
                return 0;
        }
        public static double getYFromVert(ref dataTypes.nrgTriangle triangle, ref dataTypes.nrgVertex[] vertices, int node)
        {
            if (node == 1)
                return vertices[triangle.P0].Y;
            else if (node == 2)
                return vertices[triangle.P1].Y;
            else if (node == 3)
                return vertices[triangle.P2].Y;
            else
                return 0;
        }
        public static double getNodeFromVert(ref dataTypes.nrgTriangle triangle, int node)
        {
            if (node == 1)
                return triangle.N0;
            else if (node == 2)
                return triangle.N1;
            else if (node == 3)
                return triangle.N2;
            else
                return 0;
        }
        public static bool findTri64(double X, double Y, ref dataTypes.nrgVertex[] vertices, ref dataTypes.nrgTriangle[] triangles, ref int triangle, ref int edge)
        {

            bool FoundTri = false;
            int node = 0;
            int nextnode;
            int n1;
            int n2;
            int A;
            int Count = 0;
            edge = 0;

            if (triangles.Length < 0)
            {
                triangle = 0;
            }
            else
            {
                if ((triangle == 0) || (triangle > triangles.Length))
                    triangle = triangles.Length;

                bool doLoop = true;
                double x1 = 0, y1 = 0, x2 = 0, y2 = 0;
                while (doLoop)
                {
                    node = node + 1;
                    nextnode = (node % 3) + 1;
                    n1 = node;
                    n2 = nextnode;



                    if (node == 1)
                    {
                        x1 = vertices[triangles[triangle - 1].P0].X;
                        y1 = vertices[triangles[triangle - 1].P0].Y;
                        x2 = vertices[triangles[triangle - 1].P1].X;
                        y2 = vertices[triangles[triangle - 1].P1].Y;
                    }
                    else if (node == 2)
                    {
                        x1 = vertices[triangles[triangle - 1].P1].X;
                        y1 = vertices[triangles[triangle - 1].P1].Y;
                        x2 = vertices[triangles[triangle - 1].P2].X;
                        y2 = vertices[triangles[triangle - 1].P2].Y;
                    }
                    else if (node == 3)
                    {
                        x1 = vertices[triangles[triangle - 1].P2].X;
                        y1 = vertices[triangles[triangle - 1].P2].Y;
                        x2 = vertices[triangles[triangle - 1].P0].X;
                        y2 = vertices[triangles[triangle - 1].P0].Y;
                    }

                    A = functionOnLine3(x1, y1, x2, y2, X, Y, 0.0001);
                    /*
                    A = functionOnLine3(
                        getXFromVert(ref triangles[triangle - 1], ref vertices, node),
                        getYFromVert(ref triangles[triangle - 1], ref vertices, node),
                        getXFromVert(ref triangles[triangle - 1], ref vertices, nextnode),
                        getYFromVert(ref triangles[triangle - 1], ref vertices, nextnode),
                        X, Y, 0.0001);
                        */



                    if (A > 0)
                    {
                        if (node == 1)
                        {
                            if (triangles[triangle - 1].N0 >= 0)
                                triangle = triangles[triangle - 1].N0 + 1;
                        }
                        else if (node == 2)
                        {
                            if (triangles[triangle - 1].N1 >= 0)
                                triangle = triangles[triangle - 1].N1 + 1;
                        }
                        else if (node == 3)
                        {
                            if (triangles[triangle - 1].N2 >= 0)
                                triangle = triangles[triangle - 1].N2 + 1;
                        }
                        else
                        {
                            triangle = 0;
                        }
                        Count = Count + 1;
                        node = 0;
                    }
                    else if (A == 0)
                    {
                        edge = node;
                        if (node == 1)
                        {
                            x1 = vertices[triangles[triangle - 1].P0].X;
                            y1 = vertices[triangles[triangle - 1].P0].Y;
                            x2 = vertices[triangles[triangle - 1].P1].X;
                            y2 = vertices[triangles[triangle - 1].P1].Y;
                        }
                        else if (node == 2)
                        {
                            x1 = vertices[triangles[triangle - 1].P1].X;
                            y1 = vertices[triangles[triangle - 1].P1].Y;
                            x2 = vertices[triangles[triangle - 1].P2].X;
                            y2 = vertices[triangles[triangle - 1].P2].Y;
                        }
                        else if (node == 3)
                        {
                            x1 = vertices[triangles[triangle - 1].P2].X;
                            y1 = vertices[triangles[triangle - 1].P2].Y;
                            x2 = vertices[triangles[triangle - 1].P0].X;
                            y2 = vertices[triangles[triangle - 1].P0].Y;
                        }


                        if (functionInBox2(x1, y1, x2, y2, X, Y, 0.0001))
                        {
                            node = 3;
                        }
                    }

                    if (node != 3 && triangle != 0 && Count > triangles.Length)
                    {

                        node = 0;
                        triangle = triangles.Length;

                        bool doLoop2 = true;
                        while (doLoop2)
                        {

                            node = node + 1;
                            nextnode = (node % 3) + 1;
                            n1 = node;
                            n2 = nextnode;


                            if (node == 1)
                            {
                                x1 = vertices[triangles[triangle - 1].P0].X;
                                y1 = vertices[triangles[triangle - 1].P0].Y;
                                x2 = vertices[triangles[triangle - 1].P1].X;
                                y2 = vertices[triangles[triangle - 1].P1].Y;
                            }
                            else if (node == 2)
                            {
                                x1 = vertices[triangles[triangle - 1].P1].X;
                                y1 = vertices[triangles[triangle - 1].P1].Y;
                                x2 = vertices[triangles[triangle - 1].P2].X;
                                y2 = vertices[triangles[triangle - 1].P2].Y;
                            }
                            else if (node == 3)
                            {
                                x1 = vertices[triangles[triangle - 1].P2].X;
                                y1 = vertices[triangles[triangle - 1].P2].Y;
                                x2 = vertices[triangles[triangle - 1].P0].X;
                                y2 = vertices[triangles[triangle - 1].P0].Y;
                            }

                            A = functionOnLine3(x1, y1, x2, y2, X, Y, 0.0001);

                            if (A > 0)
                            {
                                triangle = triangle - 1;
                                node = 0;
                            }
                            else if (A == 0)
                            {
                                edge = node;
                                node = 3;

                            }

                            if (node == 3 || triangle == 0)
                            {
                                doLoop2 = false;
                            }

                        }

                    }

                    if (node == 3 || triangle == 0)
                        doLoop = false;
                }
            }



            if (triangle > 0)
            {
                triangle--;
                FoundTri = true;
            }
            else
            {
                FoundTri = false;
            }

            return FoundTri;
        }

        public static bool findTri64PC(ref double X, ref double Y, ref dataTypes.nrgVertex[] vertices, ref dataTypes.nrgTriangle[] triangles, ref int triangle, ref int edge)
        {

            bool FoundTri = false;
            int node = 0;
            int nextnode;
            int n1;
            int n2;
            int A;
            int Count = 0;
            edge = 0;

            if (triangles.Length < 0)
            {
                triangle = 0;
            }
            else
            {
                if ((triangle == 0) || (triangle > triangles.Length))
                    triangle = triangles.Length;

                bool doLoop = true;
                double x1 = 0, y1 = 0, x2 = 0, y2 = 0;
                while (doLoop)
                {
                    node = node + 1;
                    nextnode = (node % 3) + 1;
                    n1 = node;
                    n2 = nextnode;



                    if (node == 1)
                    {
                        x1 = vertices[triangles[triangle - 1].P0].X;
                        y1 = vertices[triangles[triangle - 1].P0].Y;
                        x2 = vertices[triangles[triangle - 1].P1].X;
                        y2 = vertices[triangles[triangle - 1].P1].Y;
                    }
                    else if (node == 2)
                    {
                        x1 = vertices[triangles[triangle - 1].P1].X;
                        y1 = vertices[triangles[triangle - 1].P1].Y;
                        x2 = vertices[triangles[triangle - 1].P2].X;
                        y2 = vertices[triangles[triangle - 1].P2].Y;
                    }
                    else if (node == 3)
                    {
                        x1 = vertices[triangles[triangle - 1].P2].X;
                        y1 = vertices[triangles[triangle - 1].P2].Y;
                        x2 = vertices[triangles[triangle - 1].P0].X;
                        y2 = vertices[triangles[triangle - 1].P0].Y;
                    }

                    A = functionOnLine3(x1, y1, x2, y2, X, Y, 0.0001);
                    /*
                    A = functionOnLine3(
                        getXFromVert(ref triangles[triangle - 1], ref vertices, node),
                        getYFromVert(ref triangles[triangle - 1], ref vertices, node),
                        getXFromVert(ref triangles[triangle - 1], ref vertices, nextnode),
                        getYFromVert(ref triangles[triangle - 1], ref vertices, nextnode),
                        X, Y, 0.0001);
                        */



                    if (A > 0)
                    {
                        if (node == 1)
                        {
                            if (triangles[triangle - 1].N0 >= 0)
                                triangle = triangles[triangle - 1].N0 + 1;
                        }
                        else if (node == 2)
                        {
                            if (triangles[triangle - 1].N1 >= 0)
                                triangle = triangles[triangle - 1].N1 + 1;
                        }
                        else if (node == 3)
                        {
                            if (triangles[triangle - 1].N2 >= 0)
                                triangle = triangles[triangle - 1].N2 + 1;
                        }
                        else
                        {
                            triangle = 0;
                        }
                        Count = Count + 1;
                        node = 0;
                    }
                    else if (A == 0)
                    {
                        edge = node;
                        if (node == 1)
                        {
                            x1 = vertices[triangles[triangle - 1].P0].X;
                            y1 = vertices[triangles[triangle - 1].P0].Y;
                            x2 = vertices[triangles[triangle - 1].P1].X;
                            y2 = vertices[triangles[triangle - 1].P1].Y;
                        }
                        else if (node == 2)
                        {
                            x1 = vertices[triangles[triangle - 1].P1].X;
                            y1 = vertices[triangles[triangle - 1].P1].Y;
                            x2 = vertices[triangles[triangle - 1].P2].X;
                            y2 = vertices[triangles[triangle - 1].P2].Y;
                        }
                        else if (node == 3)
                        {
                            x1 = vertices[triangles[triangle - 1].P2].X;
                            y1 = vertices[triangles[triangle - 1].P2].Y;
                            x2 = vertices[triangles[triangle - 1].P0].X;
                            y2 = vertices[triangles[triangle - 1].P0].Y;
                        }


                        if (functionInBox2(x1, y1, x2, y2, X, Y, 0.0001))
                        {
                            node = 3;
                        }
                    }

                    if (node != 3 && triangle != 0 && Count > triangles.Length)
                    {

                        node = 0;
                        triangle = triangles.Length;

                        bool doLoop2 = true;
                        while (doLoop2)
                        {

                            node = node + 1;
                            nextnode = (node % 3) + 1;
                            n1 = node;
                            n2 = nextnode;


                            if (node == 1)
                            {
                                x1 = vertices[triangles[triangle - 1].P0].X;
                                y1 = vertices[triangles[triangle - 1].P0].Y;
                                x2 = vertices[triangles[triangle - 1].P1].X;
                                y2 = vertices[triangles[triangle - 1].P1].Y;
                            }
                            else if (node == 2)
                            {
                                x1 = vertices[triangles[triangle - 1].P1].X;
                                y1 = vertices[triangles[triangle - 1].P1].Y;
                                x2 = vertices[triangles[triangle - 1].P2].X;
                                y2 = vertices[triangles[triangle - 1].P2].Y;
                            }
                            else if (node == 3)
                            {
                                x1 = vertices[triangles[triangle - 1].P2].X;
                                y1 = vertices[triangles[triangle - 1].P2].Y;
                                x2 = vertices[triangles[triangle - 1].P0].X;
                                y2 = vertices[triangles[triangle - 1].P0].Y;
                            }

                            A = functionOnLine3(x1, y1, x2, y2, X, Y, 0.0001);

                            if (A > 0)
                            {
                                triangle = triangle - 1;
                                node = 0;
                            }
                            else if (A == 0)
                            {
                                edge = node;
                                node = 3;

                            }

                            if (node == 3 || triangle == 0)
                            {
                                doLoop2 = false;
                            }

                        }

                    }

                    if (node == 3 || triangle == 0)
                        doLoop = false;
                }
            }



            if (triangle > 0)
            {
                triangle--;
                FoundTri = true;
            }
            else
            {
                FoundTri = false;
            }

            return FoundTri;
        }
        

        public static List<dataTypes.tunnelShape> loadShapeFileToList(string filename)
        {
            //  var soureData=
            return null;
        }

        public static void trimStrings(ref string[] inputarray)
        {
            for(int i = 0; i < inputarray.Length; i++)
            {
                inputarray[i] = inputarray[i].TrimStart().TrimEnd();
            }

        }

        public static dataTypes.nrgLayer GPFFiletoGPFLayer(string inputFile)
        {
            var newGPFLayer = new dataTypes.nrgLayer();
            //Import points 
            var nrgVector3Bounds = new dataTypes.nrgVector3Bounds();
            List<string> inputStringList = reader.loadAsciiToStringList(inputFile, true);
            List<dataTypes.nrgPoint> importList = new List<dataTypes.nrgPoint>();
            List<string> notesList = new List<string>();
            int pointNumberCount = 0;
            string[] inputLineArray;
            foreach (string line in inputStringList)
            {
                inputLineArray = line.Replace("\"", "").Split(new string[] { "," }, StringSplitOptions.None);
                notesList.Clear();
                if (inputLineArray.Length > 5)
                    notesList.Add(inputLineArray[5].ToString());

                double newX = double.Parse(inputLineArray[2]);
                double newY = double.Parse(inputLineArray[3]);
                double newZ = double.Parse(inputLineArray[4]);

                if (pointNumberCount == 0)
                {
                    nrgVector3Bounds.minX = newX;
                    nrgVector3Bounds.minY = newY;
                    nrgVector3Bounds.maxX = newX;
                    nrgVector3Bounds.maxY = newY;
                    nrgVector3Bounds.minZ = newZ;
                    nrgVector3Bounds.maxZ = newZ;

                }

                if (newX > nrgVector3Bounds.maxX) nrgVector3Bounds.maxX = newX;
                if (newY > nrgVector3Bounds.maxY) nrgVector3Bounds.maxY = newY;

                if (newX < nrgVector3Bounds.minX) nrgVector3Bounds.minX = newX;
                if (newY < nrgVector3Bounds.minY) nrgVector3Bounds.minY = newY;
                //stop -999 being part of bounds
                if (newZ > -900)
                {
                    if (newZ > nrgVector3Bounds.maxZ) nrgVector3Bounds.maxZ = newZ;
                    if (newZ < nrgVector3Bounds.minZ) nrgVector3Bounds.minZ = newZ;
                }

                importList.Add(
                                new dataTypes.nrgPoint
                                {
                                    pointNumber = inputLineArray[0],
                                    coord = new dataTypes.nrgVector3
                                    {
                                        X = newX,
                                        Y = newY,
                                        Z = newZ
                                    },
                                    notesList = notesList,

                                    fieldCodeList = dataTypes.importFieldCodeStringToList(inputLineArray[1].ToString())

                                }
                );

                pointNumberCount++;
            }

            //generate Offset
            double coordOffsetXNew = (long)(nrgVector3Bounds.minX + ((nrgVector3Bounds.maxX - nrgVector3Bounds.minX) / 2));
            double coordOffsetYNew = (long)(nrgVector3Bounds.minY + ((nrgVector3Bounds.maxY - nrgVector3Bounds.minY) / 2));
            double coordOffsetZNew = (long)(nrgVector3Bounds.minZ + ((nrgVector3Bounds.maxZ - nrgVector3Bounds.minZ) / 2));

            //create initial layer object with new points and offsets
            newGPFLayer = new dataTypes.nrgLayer { fileLoaded = true, nrgPointsList = importList, coordOffsetX = coordOffsetXNew, coordOffsetY = coordOffsetYNew, coordOffsetZ = coordOffsetZNew, nrgVector3Bounds = nrgVector3Bounds, sourceFileName = inputFile };

            //finally return new layer to the object.

            return newGPFLayer;
        }


        public static void coordsOnCurve(double Chainage, double ChOrig, double EastOrig, double NorthOrig, double BrgOrig, double lastRad, double thisRad, double nextRad, double thisRL,out double east,out double north,out double tang,out double r)
        {
            double radi, Distance, bearing;
            double tangent, j, l, m;
            double EastO, northO;

            tang = 0;
            east = 0;
            north = 0;
            r = 0;

            
                Distance = Chainage - ChOrig;

                //straight
                if ((thisRad == 0) && (thisRL == 0))
                {
                    bearing = BrgOrig;
                    tangent = bearing;
                    r = 0;

                }
                //curve
                else if (thisRL == 0)
                {
                    j = Distance / (thisRad * 2);
                    bearing = BrgOrig + j;
                    tangent = BrgOrig + (2 * j);
                    Distance = (2 * thisRad) * Math.Sin(j);
                    r = thisRad;
                }
                //sprial
                else
                {
                    if (Distance == 0)
                    {
                        radi = helpers.infinity();
                    }
                    else
                    {
                        radi = Math.Abs(thisRL / Distance);
                    }

                    m = Distance / (2 * radi);
                    j = (m / 3) + ((m * m * m) / 105) + ((m * m * m * m * m) / 5997);
                    j = Math.Abs(j);
                    j = Math.Atan(j);
                    tangent = (Distance * Distance) / (2 * Math.Abs(thisRL));
                    tangent = FNAngle(tangent, 0);

                    if (Chainage > ChOrig)
                    {
                        if (nextRad < 0)
                        {
                            j = -j;
                            tangent = -tangent;
                            r = -radi;
                        }
                        else
                        {
                            r = radi;
                        }
                    }
                    else
                    {
                        if (lastRad != 0)
                        {
                            if (lastRad > 0)
                            {
                                j = -j;
                                tangent = -tangent;
                                r = radi;
                            }
                            else
                            {
                                r = -radi;
                            }
                        }
                        else
                        {
                            if (nextRad > 0)
                            {
                                j = -j;
                                tangent = -tangent;
                                r = radi;
                            }
                            else
                            {
                                r = -radi;
                            }
                        }
                    }

                    bearing = BrgOrig + j;
                    tangent = BrgOrig + tangent;
                    tangent = FNAngle(tangent, 0);
                    l = Distance;
                    Distance = l - ((l * l * l) / (40 * (radi * radi))) + ((l * l * l * l * l) / (3456 * (radi * radi * radi * radi)));
                    Distance = Distance /  Math.Cos(j);
                }
                EastO = EastOrig;
                northO = NorthOrig;
                double oEast = 0;double oNorth = 0;
                PRC(EastO, northO, bearing, Distance, ref oEast, ref oNorth, 1);
                east = oEast;
                north = oNorth;
                tang = tangent;
                while (tang > 2 * Math.PI)
                {
                    tang = tang - 2 * Math.PI;
                }
             
            
        }

        public static void geometry2Coords(double Chstart, double ChOrigin, double eastOrigin, double northOrigin, double BrgOrigin, double radius, double rl, double prevRadius, double nextRadius, double nextChstart,ref HorizontalElementType eletype, ref double eastStart, ref double northStart, ref double RadiusStart, ref double length, ref bool newele, ref double eaststart2, ref double northStart2)
        {
            double tang;
         

            if ((rl==0)&&((radius==0)||(Math.Abs(radius)> 100000000)))
            {
                eletype = 0;
                eastStart = eastOrigin;
                northStart = northOrigin;
                RadiusStart = 0;

            }
            else if (rl == 0)
            {
                eletype = HorizontalElementType.Arc;
                eastStart = eastOrigin;
                northStart = northOrigin;
                RadiusStart = radius;
                if (nextChstart != 0)
                {
                    if(nextChstart-Chstart > Math.Abs(radius) * Math.PI)
                    {
                        newele = true;
                        BrgOrigin = BrgOrigin + Math.PI;
                        if (BrgOrigin > 2 * Math.PI) { BrgOrigin = BrgOrigin - 2 * Math.PI; }
                        PRC(eastStart, northStart, BrgOrigin - Math.PI / 2, 2 * radius,ref eaststart2, ref northStart2, 1);
                    }
                }
            }
            else
            {
                eletype = HorizontalElementType.Spiral;
                coordsOnCurve(Chstart, ChOrigin, eastOrigin, northOrigin, BrgOrigin, prevRadius, radius, nextRadius, rl, out eastStart, out northStart, out tang, out RadiusStart);
                if(Math.Abs(RadiusStart)> 100000000)
                {
                    RadiusStart = 0;
                }
                if (nextChstart == 0)
                {
                    length = Math.Abs(rl / RadiusStart);
                }
                else
                {
                    length = Math.Abs(nextChstart - Chstart);
                }
            }
            
        }


        public static double Helmert_X(double X, double Y, double Z, double dx, double Y_Rot, double Z_Rot, double s)
        {
            //Computed Helmert transformed X coordinate.
            //Input: - _
            //cartesian XYZ coords(X, Y, Z), X translation(DX) all in meters; _
            //Y and Z rotations in seconds of arc(Y_Rot, Z_Rot) and scale in ppm(s).


            //'Convert rotations to radians and ppm scale to a factor

            double sfactor = s * 0.000001;
            double RadY_Rot = (Y_Rot / 3600) * (Math.PI / 180);
            double RadZ_Rot = (Z_Rot / 3600) * (Math.PI / 180);
            return X + (X * sfactor) - (Y * RadZ_Rot) + (Z * RadY_Rot) + dx;


        }

        public static double Helmert_Y(double X, double Y, double z, double dy, double X_Rot, double Z_Rot, double s)
        {
            /*
			  'Computed Helmert transformed Y coordinate.
				 Input: - _
				 cartesian XYZ coords(X, Y, Z), Y translation(DY) all in meters ; _
				 X and Z rotations in seconds of arc(X_Rot, Z_Rot) and scale in ppm(s).
			*/
            double sfactor = s * 0.000001;
            double RadX_Rot = (X_Rot / 3600) * (Math.PI / 180);
            double RadZ_Rot = (Z_Rot / 3600) * (Math.PI / 180);
            return (X * RadZ_Rot) + Y + (Y * sfactor) - (z * RadX_Rot) + dy;
        }

        public static double Helmert_Z(double X, double Y, double z, double dz, double X_Rot, double Y_Rot, double s)
        {
            double sfactor = s * 0.000001;

            double RadX_Rot = (X_Rot / 3600) * (Math.PI / 180);
            double RadY_Rot = (Y_Rot / 3600) * (Math.PI / 180);
            return (-1 * X * RadY_Rot) + (Y * RadX_Rot) + z + (z * sfactor) + dz;
        }

        public static double XYZ_to_Lat(double X, double Y, double z, double A, double b)
        {
            double RootXYSqr = Math.Sqrt(Math.Pow(X, 2) + Math.Pow(Y, 2));
            double e2 = (Math.Pow(A, 2) - Math.Pow(b, 2)) / Math.Pow(A, 2);
            double PHI1 = Math.Atan(z / (RootXYSqr * (1 - e2)));
            double phi = Iterate_XYZ_to_Lat(A, e2, PHI1, z, RootXYSqr);

            return phi * (180 / Math.PI);
        }


        public static double Iterate_XYZ_to_Lat(double A, double e2, double PHI1, double z, double RootXYSqr)
        {

            /*Iteratively computes Latitude (PHI).
			'Input: - _
			 ellipsoid semi major axis(a) in meters; _
			eta squared(e2); _
			estimated value for latitude(PHI1) in radians; _

			cartesian Z coordinate(Z) in meters; _
			RootXYSqr computed from X & Y in meters.*/
            double v = A / (Math.Sqrt(1 - (e2 * ((Math.Pow(Math.Sin(PHI1), 2))))));
            double PHI2 = Math.Atan((z + (e2 * v * (Math.Sin(PHI1)))) / RootXYSqr);

            do
            {
                PHI1 = PHI2;
                v = A / (Math.Sqrt(1 - (e2 * ((Math.Pow(Math.Sin(PHI1), 2))))));
                PHI2 = Math.Atan((z + (e2 * v * (Math.Sin(PHI1)))) / RootXYSqr);
            } while (Math.Abs(PHI1 - PHI2) > 0.000000001);

            return PHI2;

        }
        /// <summary>
        /// XYZ_to_Long: Convert XYZ to Longitude (LAM) in decimal degrees.
        /// tailor the output to fit the equatorial quadrant as determined by the signs of X and Y
        /// </summary>
        /// <param name="X" Cartesian coords in meters></param>
        /// <param name="Y" Cartesian coords in meters></param>
        /// <returns> The fucking answer...duh</returns>
		public static double XYZ_to_Long(double X, double Y)
        {

            if (X >= 0)
            {
                return (Math.Atan(Y / X)) * (180 / Math.PI);
            }
            else if (X < 0 & Y >= 0)
            {
                return ((Math.Atan(Y / X)) * (180 / Math.PI)) + 180;
            }
            else //(X<0 & Y<0) // check this
            {
                return ((Math.Atan(Y / X)) * (180 / Math.PI)) - 180;
            }
        }


        /// 
        /// </summary>
        /// XYZ_to_H
        /// REQUIRES THE "XYZ_to_Lat" FUNCTION
        /// <param name="X"></param>
        /// <param name="Y"></param>
        /// <param name="z"></param>
        /// <param name="A"></param>
        /// <param name="b"></param>
        /// <returns></returns>
        public static double XYZ_to_H(double X, double Y, double z, double A, double b)
        {
            ///
            double phi = XYZ_to_Lat(X, Y, z, A, b);
            double RadPHI = phi * (Math.PI / 180);
            double RootXYSqr = Math.Sqrt(Math.Pow(X, 2) + Math.Pow(Y, 2));
            double e2 = (Math.Pow(A, 2) - Math.Pow(b, 2)) / Math.Pow(A, 2);
            double v = A / (Math.Sqrt(1 - (e2 * Math.Pow(Math.Sin(RadPHI), 2))));
            double h = (RootXYSqr / Math.Cos(RadPHI)) - v;
            return h;
        }

        /// <summary>
        /// Lat_Long_H_to_X: Convert geodetic coords lat (PHI), long (LAM) and height (H) to cartesian X coordinate.
        /// </summary>
        /// <param name="phi"></param>
        /// <param name="LAM"></param>
        /// <param name="h"></param>
        /// <param name="A"></param>
        /// <param name="b"></param>
        /// <returns></returns>

        public static double Lat_Long_H_to_X(double phi, double LAM, double h, double A, double b)
        {
            //Convert angle measures to radians
            double RadPHI = phi * (Math.PI / 180);
            double RadLAM = LAM * (Math.PI / 180);
            //Compute eccentricity squared and nu
            double e2 = (Math.Pow(A, 2) - Math.Pow(b, 2)) / Math.Pow(A, 2);
            double v = A / (Math.Sqrt(1 - (e2 * (Math.Pow(Math.Sin(RadPHI), 2)))));
            //Compute X...Tadah
            return (v + h) * (Math.Cos(RadPHI)) * (Math.Cos(RadLAM));
        }


        /// <summary>
        /// Lat_Long_H_to_Y: Convert geodetic coords lat (PHI), long (LAM) and height (H) to cartesian Y coordinate
        /// </summary>
        /// <param name="phi"></param>
        /// <param name="LAM"></param>
        /// <param name="h"></param>
        /// <param name="A"></param>
        /// <param name="b"></param>
        /// <returns></returns>
        public static double Lat_Long_H_to_Y(double phi, double LAM, double h, double A, double b)
        {
            //Convert angle measures to radians, whooda thunk it!
            double RadPHI = phi * (Math.PI / 180);
            double RadLAM = LAM * (Math.PI / 180);

            //Compute eccentricity squared and nu
            double e2 = (Squared(A) - Squared(b)) / Squared(A);
            double v = A / (Math.Sqrt(1 - (e2 * ((Squared(Math.Sin(RadPHI)))))));

            return (v + h) * (Math.Cos(RadPHI)) * (Math.Sin(RadLAM));
        }

        /// <summary>
        /// Lat_H_to_Z: Convert geodetic coord components latitude (PHI) and height (H) to cartesian Z coordinate.
        /// Latitude (PHI) decimal degrees; Ellipsoidal height(H) and ellipsoid axis dimensions(a & b) all in meters.
        /// </summary>
        /// <param name="phi"></param>
        /// <param name="h"></param>
        /// <param name="A"></param>
        /// <param name="b"></param>
        /// <returns></returns>
        public static double Lat_H_to_Z(double phi, double h, double A, double b)
        {
            //Convert angle measures to radians
            double RadPHI = phi * (Math.PI / 180);
            //Compute eccentricity squared and nu
            double e2 = (Squared(A) - Squared(b)) / Squared(A);
            double v = A / (Math.Sqrt(1 - (e2 * (Squared(Math.Sin(RadPHI))))));
            return ((v * (1 - e2)) + h) * (Math.Sin(RadPHI));
        }

        /// <summary>
        /// Lat_Long_to_East: Project Latitude and longitude to Transverse Mercator eastings.
        ///Latitude (PHI) and Longitude (LAM) in decimal degrees; _
        ///ellipsoid axis dimensions(a & b) in meters; _
        ///eastings of false origin(e0) in meters; _
        ///central meridian scale factor(f0); _
        ///latitude(PHI0) and longitude(LAM0) of false origin in decimal degrees.
        /// </summary>
        /// <param name="phi"></param>
        /// <param name="LAM"></param>
        /// <param name="A"></param>
        /// <param name="b"></param>
        /// <param name="e0"></param>
        /// <param name="f0"></param>
        /// <param name="PHI0"></param>
        /// <param name="LAM0"></param>
        /// <returns></returns>
        public static double Lat_Long_to_East(double phi, double LAM, double A, double b, double e0, double f0, double PHI0, double LAM0)
        {
            //Convert angle measures to radians
            double RadPHI = phi * (Math.PI / 180);
            double RadLAM = LAM * (Math.PI / 180);
            double RadPHI0 = PHI0 * (Math.PI / 180);
            double RadLAM0 = LAM0 * (Math.PI / 180);

            double af0 = A * f0;
            double bf0 = b * f0;
            double e2 = (Squared(af0) - Squared(bf0)) / Squared(af0);
            double n = (af0 - bf0) / (af0 + bf0);
            double nu = af0 / (Math.Sqrt(1 - (e2 * ((Squared(Math.Sin(RadPHI)))))));
            double rho = (nu * (1 - e2)) / (1 - Squared(e2 * (Math.Sin(RadPHI))));
            double eta2 = (nu / rho) - 1;
            double p = RadLAM - RadLAM0;
            

            double IV = nu * (Math.Cos(RadPHI));
            // TODO:Check this
            double v = (nu / 6) * (Math.Pow((Math.Cos(RadPHI)), 3)) * ((nu / rho) - ((Math.Pow(Math.Tan(RadPHI), 2))));
            double VI = (nu / 120) * (Math.Pow((Math.Cos(RadPHI)), 5)) * (5 - (18 * (Squared(Math.Tan(RadPHI)))) + (Math.Pow((Math.Tan(RadPHI)), 4)) + (14 * eta2) - (58 * (Math.Pow((Math.Tan(RadPHI)), 2)) * eta2));
            return e0 + (p * IV) + ((Math.Pow(p, 3)) * v) + ((Math.Pow(p, 5)) * VI);


        }


        public static double Lat_Long_to_North(double phi, double LAM, double A, double b, double e0, double n0, double f0, double PHI0, double LAM0)
        {
            //Project Latitude and longitude to Transverse Mercator northings
            /* Input: - _
             Latitude (PHI) and Longitude (LAM) in decimal degrees; _
             ellipsoid axis dimensions (a & b) in meters; _
             eastings (e0) and northings (n0) of false origin in meters; _
             central meridian scale factor (f0); _
             latitude (PHI0) and longitude (LAM0) of false origin in decimal degrees.
            */
            //REQUIRES THE "Marc" FUNCTION

            //Convert angle measures to radians
            //Math.PI = 3.14159265358979
            double RadPHI = phi * (Math.PI / 180);
            double RadLAM = LAM * (Math.PI / 180);
            double RadPHI0 = PHI0 * (Math.PI / 180);
            double RadLAM0 = LAM0 * (Math.PI / 180);

            double af0 = A * f0;
            double bf0 = b * f0;
            double e2 = ((Math.Pow(af0, 2)) - (Math.Pow(bf0, 2))) / (Math.Pow(af0, 2));
            double n = (af0 - bf0) / (af0 + bf0);
            double nu = af0 / (Math.Sqrt(1 - (e2 * (Math.Pow((Math.Sin(RadPHI)), 2)))));
            double rho = (nu * (1 - e2)) / (1 - (e2 * Math.Pow((Math.Sin(RadPHI)), 2)));
            double eta2 = (nu / rho) - 1;
            double p = RadLAM - RadLAM0;
            double m = Marc(bf0, n, RadPHI0, RadPHI);

            double i = m + n0;
            double ii = (nu / 2) * (Math.Sin((RadPHI))) * (Math.Cos((RadPHI)));
            double iii = ((nu / 24) * (Math.Sin((RadPHI))) * (Math.Pow((Math.Cos((RadPHI))),3))) * (5 - (Math.Pow((Math.Tan((RadPHI))),2)) + (9 * eta2));
            double IIIA = ((nu / 720) * (Math.Sin(RadPHI)) * (Math.Pow( (Math.Cos(RadPHI)), 5))) * (61 - (58 * ( Math.Pow((Math.Tan(RadPHI)),2))) + (Math.Pow((Math.Tan(RadPHI)), 4)));
       
            double output = i + ((Math.Pow(p,2)) * ii) + ((Math.Pow(p,4)) * iii) + ((Math.Pow(p,6)) * IIIA);
            return output;
        }

        public static double Marc(double bf0, double n ,double PHI0, double phi) {



            // Function Marc(bf0, n, PHI0, phi)
            // 'Compute meridional arc.
            // 'Input: - _
            //  ellipsoid semi major axis multiplied by central meridian scale factor(bf0) in meters; _
            // n(computed from a, b and f0); _
            // lat of false origin(PHI0) and initial or final latitude of point(PHI) IN RADIANS.
            // 'THIS FUNCTION IS CALLED BY THE - _
            //  "Lat_Long_to_North" and "InitialLat" FUNCTIONS
            // 'THIS FUNCTION IS ALSO USED ON IT'S OWN IN THE "Projection and Transformation Calculations.xls" SPREADSHEET

            //return bf0 * (((1 + n + ((5 / 4) * (Math.Pow(n,2D))) + ((5 / 4) * (Math.Pow(n,3D)))) * (phi - PHI0)) 
            //            - (((3 * n) + (3 * (Math.Pow(n,2D))) + ((21 / 8) * (Math.Pow(n,3D)))) * (Math.Sin(phi - PHI0)) * (Math.Cos(phi + PHI0))) 
            //            + ((((15 / 8) * (Math.Pow(n,2D))) + ((15 / 8) * (Math.Pow(n,3D)))) * (Math.Sin(2 * (phi - PHI0))) * (Math.Cos(2 * (phi + PHI0)))) 
            //            - (((35 / 24) * (Math.Pow(n,3D))) * (Math.Sin(3 * (phi - PHI0))) * (Math.Cos(3 * (phi + PHI0)))));
            return bf0 * (((1D + n + ((5D / 4D) * (n * n)) + ((5D / 4D) * (n * n * n))) * (phi - PHI0))
                        - (((3D * n) + (3D * (n * n)) + ((21D / 8D) * (n * n * n))) * (Math.Sin(phi - PHI0)) * (Math.Cos(phi + PHI0)))
                         + ((((15D / 8D) * (n * n)) + ((15D / 8D) * (n * n * n))) * (Math.Sin(2D * (phi - PHI0))) * (Math.Cos(2D * (phi + PHI0))))
                        - (((35D / 24D) * (n * n * n)) * (Math.Sin(3 * (phi - PHI0))) * (Math.Cos(3D * (phi + PHI0)))));
           }


        public static double E_N_to_Lat(double east, double north, double A, double b, double e0, double n0, double f0, double PHI0, double LAM0)
        {
            //'Un-project Transverse Mercator eastings and northings back to latitude.
            //'Input: - _
            // eastings (East) and northings (North) in meters; _
            // ellipsoid axis dimensions (a & b) in meters; _
            // eastings (e0) and northings (n0) of false origin in meters; _
            // central meridian scale factor (f0) and _
            // latitude (PHI0) and longitude (LAM0) of false origin in decimal degrees.

            //'REQUIRES THE "Marc" AND "InitialLat" FUNCTIONS

            double RadPHI0 = PHI0 * (Math.PI / 180);
            double RadLAM0 = LAM0 * (Math.PI / 180);

            //Convert angle measures to radians
            //'PI = 3.14159265358979
            RadPHI0 = PHI0 * (Math.PI / 180);
            RadLAM0 = LAM0 * (Math.PI / 180);

            //Compute af0, bf0, e squared (e2), n and Et
            double af0 = A * f0;
            double bf0 = b * f0;
            double e2 = ((Math.Pow(af0,2)) - (Math.Pow(bf0,2))) / (Math.Pow(af0,2));
            double n = (af0 - bf0) / (af0 + bf0);
            double Et = east - e0;

            //Compute initial value for latitude (PHI) in radians
            double PHId = InitialLat(north, n0, af0, RadPHI0, n, bf0);

            //Compute nu, rho and eta2 using value for PHId
            double nu = af0 / (Math.Sqrt(1 - (e2 * ( Math.Pow((Math.Sin(PHId)),2)))));
            double rho = (nu * (1 - e2)) / (1 - (e2 * Math.Pow((Math.Sin(PHId)),2)));
            double eta2 = (nu / rho) - 1;

            //Compute Latitude
            double VII = (Math.Tan(PHId)) / (2 * rho * nu);
            double VIII = ((Math.Tan(PHId)) / (24 * rho * (Math.Pow(nu,3)))) * (5 + (3 * (Math.Pow((Math.Tan(PHId)),2))) + eta2 - (9 * eta2 * (Math.Pow((Math.Tan(PHId)),2))));
            double ix = ((Math.Tan(PHId)) / (720 * rho * (Math.Pow(nu,5)))) * (61 + (90 * (Math.Pow((Math.Tan(PHId)),2))) + (45 * (Math.Pow((Math.Tan(PHId)),4))));

            double output = (180 / Math.PI) * (PHId - ((Math.Pow(Et,2)) * VII) + ((Math.Pow(Et,4)) * VIII) - ((Math.Pow(Et,6)) * ix));
            return output;

        }

        public static double InitialLat(double north, double n0, double afo, double PHI0, double n, double bfo)
        {
            //Compute initial value for Latitude (PHI) IN RADIANS.
            //Input: - _
            // northing of point (North) and northing of false origin (n0) in meters; _
            //semi major axis multiplied by central meridian scale factor (af0) in meters; _
            // latitude of false origin (PHI0) IN RADIANS; _
            // n (computed from a, b and f0) and _
            // ellipsoid semi major axis multiplied by central meridian scale factor (bf0) in meters.

            //REQUIRES THE "Marc" FUNCTION
            //'THIS FUNCTION IS CALLED BY THE "E_N_to_Lat", "E_N_to_Long" and "E_N_to_C" FUNCTIONS.
            //'THIS FUNCTION IS ALSO USED ON IT'S OWN IN THE  "Projection and Transformation Calculations.xls" SPREADSHEET

            //First PHI value (PHI1)
            double PHI1 = ((north - n0) / afo) + PHI0;

            //Calculate M
            double m = Marc(bfo, n, PHI0, PHI1);

            //Calculate new PHI value (PHI2)
            double PHI2 = ((north - n0 - m) / afo) + PHI1;

            //Iterate to get final value for InitialLat
            while (Math.Abs(north -n0 - m) > 0.00001){
                PHI2 = ((north - n0 - m) / afo) + PHI1;
                m = Marc(bfo, n, PHI0, PHI2);
                PHI1 = PHI2;
            }

            return PHI2;
        }

        public static double E_N_to_Long(double east, double north, double A, double b, double e0, double n0, double f0, double PHI0, double LAM0)
        {
            //Un-project Transverse Mercator eastings and northings back to longitude.
            //Input: - _
            // eastings (East) and northings (North) in meters; _
            // ellipsoid axis dimensions (a & b) in meters; _
            // eastings (e0) and northings (n0) of false origin in meters; _
            // central meridian scale factor (f0) and _
            // latitude (PHI0) and longitude (LAM0) of false origin in decimal degrees.

            //REQUIRES THE "Marc" AND "InitialLat" FUNCTIONS

            //Convert angle measures to radians
            //'PI = 3.14159265358979
            double RadPHI0 = PHI0 * (Math.PI / 180);
            double RadLAM0 = LAM0 * (Math.PI / 180);

            //Compute af0, bf0, e squared (e2), n and Et
            double af0 = A * f0;
            double bf0 = b * f0;
            double e2 = ((Math.Pow( af0,2)) - (Math.Pow( bf0,2))) / (Math.Pow( af0,2));
            double n = (af0 - bf0) / (af0 + bf0);
            double Et = east - e0;

            //Compute initial value for latitude (PHI) in radians
            double PHId = InitialLat(north, n0, af0, RadPHI0, n, bf0);

            //Compute nu, rho and eta2 using value for PHId
            double nu = af0 / (Math.Sqrt(1 - (e2 * ( Math.Pow((Math.Sin(PHId)),2)))));
            double rho = (nu * (1 - e2)) / (1 - (e2 * Math.Pow((Math.Sin(PHId)),2)));
            double eta2 = (nu / rho) - 1;

            //Compute Longitude
            double X = ( Math.Pow((Math.Cos(PHId)),-1)) / nu;
            double Xi = ((Math.Pow((Math.Cos(PHId)),-1)) / (6 * (Math.Pow( nu,3)))) * ((nu / rho) + (2 * ( Math.Pow((Math.Tan(PHId)),2))));
            double XII = (( Math.Pow((Math.Cos(PHId)),-1)) / (120 * (Math.Pow(nu,5)))) * (5 + (28 * (Math.Pow((Math.Tan(PHId)),2))) + (24 * (Math.Pow( (Math.Tan(PHId)),4))));
            double XIIA = ((Math.Pow( (Math.Cos(PHId)),-1)) / (5040 * (Math.Pow( nu,7)))) * (61 + (662 * (Math.Pow( (Math.Tan(PHId)),2))) + (1320 * (Math.Pow( (Math.Tan(PHId)),4))) + (720 * (Math.Pow((Math.Tan(PHId)),6))));

            return (180 / Math.PI) * (RadLAM0 + (Et * X) - ((Math.Pow( Et,3)) * Xi) + ((Math.Pow( Et,5)) * XII) - ((Math.Pow( Et,7)) * XIIA));

        }




        public static double Lat_Long_to_C(double phi, double LAM, double LAM0, double A, double b, double f0)
        {
            //Compute convergence (in decimal degrees) from latitude and longitude
            //Input: - _
            // latitude (PHI), longitude (LAM) and longitude (LAM0) of false origin in decimal degrees; _
            // ellipsoid axis dimensions (a & b) in meters; _
            // central meridian scale factor (f0).

            //Convert angle measures to radians
            //   'PI = 3.14159265358979
            double RadPHI = phi * (Math.PI / 180);
            double RadLAM = LAM * (Math.PI / 180);
            double RadLAM0 = LAM0 * (Math.PI / 180);

            //Compute af0, bf0 and e squared (e2)
            double af0 = A * f0;
            double bf0 = b * f0;
            double e2 = ((Math.Pow( af0,2)) - (Math.Pow( bf0,2))) / ( Math.Pow( af0,2));

            //Compute nu, rho, eta2 and p
            double nu = af0 / (Math.Sqrt(1 - (e2 * ( Math.Pow((Math.Sin(RadPHI)),2)))));
            double rho = (nu * (1 - e2)) / (1 - (e2 *  Math.Pow((Math.Sin(RadPHI)),2)));
            double eta2 = (nu / rho) - 1;
            double p = RadLAM - RadLAM0;

            //Compute Convergence
            double XIII = Math.Sin(RadPHI);
            double XIV = ((Math.Sin(RadPHI) * ( Math.Pow((Math.Cos(RadPHI)),2))) / 3) * (1 + (3 * eta2) + (2 * (Math.Pow( eta2,2))));
            double XV = ((Math.Sin(RadPHI) * ( Math.Pow((Math.Cos(RadPHI)),4)) ) / 15) * (2 - ( Math.Pow((Math.Tan(RadPHI)),2)));

            return (180 / Math.PI) * ((p * XIII) + ((Math.Pow( p,3)) * XIV) + ((Math.Pow( p,5)) * XV));

        }

        public static double E_N_to_C(double east, double north, double A, double b, double e0, double n0, double f0, double PHI0)
        {
            //Compute convergence (in decimal degrees) from easting and northing
            //Input: - _
            // Eastings (East) and Northings (North) in meters; _
            // ellipsoid axis dimensions (a & b) in meters; _
            // easting (e0) and northing (n0) of true origin in meters; _
            // central meridian scale factor (f0); _
            // latitude of central meridian (PHI0) in decimal degrees.

            //REQUIRES THE "Marc" AND "InitialLat" FUNCTIONS

            //Convert angle measures to radians
            //PI = 3.14159265358979
            double RadPHI0 = PHI0 * (Math.PI / 180);

            //Compute af0, bf0, e squared (e2), n and Et
            double af0 = A * f0;
            double bf0 = b * f0;
            double e2 = ((Math.Pow( af0,2)) - (Math.Pow( bf0,2))) / (Math.Pow( af0,2));
            double n = (af0 - bf0) / (af0 + bf0);
            double Et = east - e0;

            //Compute initial value for latitude (PHI) in radians
            double PHId = InitialLat(north, n0, af0, RadPHI0, n, bf0);

            //Compute nu, rho and eta2 using value for PHId
            double nu = af0 / (Math.Sqrt(1 - (e2 * ( Math.Pow((Math.Sin(PHId)),2)))));
            double rho = (nu * (1 - e2)) / (1 - (e2 * Math.Pow(( Math.Sin(PHId)),2)));
            double eta2 = (nu / rho) - 1;

            //Compute Convergence
            double XVI = (Math.Tan(PHId)) / nu;
            double XVII = ((Math.Tan(PHId)) / (3 * (Math.Pow( nu,3)))) * (1 + (Math.Pow( (Math.Tan(PHId)),2)) - eta2 - (2 * (Math.Pow( eta2,2))));
            double XVIII = ((Math.Tan(PHId)) / (15 * (Math.Pow( nu,5)))) * (2 + (5 * (Math.Pow( (Math.Tan(PHId)),2))) + (3 * ( Math.Pow((Math.Tan(PHId)),4))));

            return (180 / Math.PI) * ((Et * XVI) - ((Math.Pow( Et,3)) * XVII) + ((Math.Pow( Et,5)) * XVIII));

        }

        //Input latitude (PHI), longitude (LAM), Longitude of false origin in decimal degrees (LAM0), ellipsoid axis (a & b ) in meters, central meridian scale factor (f0)
        private double latLongToLSF(double PHI, double LAM, double LAM0, double a, double b, double f0)
        {
            double RadPHI = PHI * (Math.PI / 180);
            double RadLAM = LAM * (Math.PI / 180);
            double RADLAM0 = LAM0/* * (Math.PI / 180)*/;

            double af0 = a * f0;
            double bf0 = b * f0;
            double e2 = (Math.Pow(af0, 2) - Math.Pow(bf0, 2)) / Math.Pow(af0, 2);

            double nu = af0 / Math.Sqrt(1 - (e2 * Math.Sin(RadPHI)));
            double rho = (nu * (1 - e2)) / (1 - (e2 * Math.Sin(RadPHI)));
            double eta2 = (nu / rho) - 1;
            double p = RadLAM - RADLAM0;

            double XIX = (Math.Pow(Math.Cos(RadPHI), 2) / 2) * (1 + eta2);

            double XX = (Math.Pow(Math.Cos(RadPHI), 4) / 24)
                        *
                        (
                            5 - 4 * Math.Pow(Math.Tan(RadPHI), 2) +
                            (14 * eta2) -
                            28 * Math.Pow(Math.Tan(RadPHI * eta2), 2)
                        );

            return f0 * (1 + ((Math.Pow(p, 2)) * XIX) + ((Math.Pow(p, 4)) * XX));
        }



        public static double E_N_to_LSF(double east, double north, double A, double b, double e0, double n0, double f0, double PHI0)
        {
            //Compute local scale factor from from easting and northing
            //Input: - _
            // Eastings (East) and Northings (North) in meters; _
            // ellipsoid axis dimensions (a & b) in meters; _
            // easting (e0) and northing (n0) of true origin in meters; _
            // central meridian scale factor (f0); _
            // latitude of central meridian (PHI0) in decimal degrees.

            //REQUIRES THE "Marc" AND "InitialLat" FUNCTIONS


            //Convert angle measures to radians
            //PI = 3.14159265358979
            double RadPHI0 = PHI0 * (Math.PI / 180);

            //Compute af0, bf0, e squared (e2), n and Et
            double af0 = A * f0;
            double bf0 = b * f0;
            double e2 = ((Math.Pow( af0,2)) - (Math.Pow( bf0,2))) / (Math.Pow( af0,2));
            double n = (af0 - bf0) / (af0 + bf0);
            double Et = east - e0;

            //Compute initial value for latitude (PHI) in radians
            double PHId = InitialLat(north, n0, af0, RadPHI0, n, bf0);

            //Compute nu, rho and eta2 using value for PHId
            double nu = af0 / (Math.Sqrt(1 - (e2 * ( Math.Pow( (Math.Sin(PHId)),2)))));
            double rho = (nu * (1 - e2)) / (1 - (e2 * Math.Pow( (Math.Sin(PHId)),2)));
            double eta2 = (nu / rho) - 1;

            //Compute local scale factor
            double XXI = 1 / (2 * rho * nu);
            double XXII = (1 + (4 * eta2)) / (24 * (Math.Pow( rho,2)) * (Math.Pow( nu,2)));

            return f0 * (1 + ((Math.Pow( Et,2)) * XXI) + ((Math.Pow( Et,4)) * XXII));


        }


        public static double E_N_to_t_minus_T(double AtEast, double AtNorth, double ToEast, double ToNorth, double A, double b, double e0, double n0, double f0, double PHI0)
        {
            //Compute (t-T) correction in decimal degrees at point (AtEast, AtNorth) to point (ToEast,ToNorth)
            //Input: - _
            // Eastings (AtEast) and Northings (AtNorth) in meters, of point where (t-T) is being computed; _
            // Eastings (ToEast) and Northings (ToNorth) in meters, of point at other end of line to which (t-T) is being computed; _
            // ellipsoid axis dimensions (a & b) and easting & northing (e0 & n0) of true origin in meters; _
            // central meridian scale factor (f0); _
            // latitude of central meridian (PHI0) in decimal degrees.

            //.REQUIRES THE "Marc" AND "InitialLat" FUNCTIONS

            //Convert angle measures to radians
            //  'PI = 3.14159265358979
            double RadPHI0 = PHI0 * (Math.PI / 180);

            //Compute af0, bf0, e squared (e2), n and Nm (Northing of mid point)
            double af0 = A * f0;
            double bf0 = b * f0;
            double e2 = ((Math.Pow( af0,2)) - (Math.Pow( bf0,2))) / (Math.Pow( af0,2));
            double n = (af0 - bf0) / (af0 + bf0);
            double nm = (AtNorth + ToNorth) / 2;

            //Compute initial value for latitude (PHI) in radians;
            double PHId = InitialLat(nm, n0, af0, RadPHI0, n, bf0);

            //Compute nu, rho and eta2 using value for PHId
            double nu = af0 / (Math.Sqrt(1 - (e2 * ( Math.Pow((Math.Sin(PHId)),2)))));
            double rho = (nu * (1 - e2)) / (1 - (e2 *  Math.Pow((Math.Sin(PHId)),2)));

            //Compute (t-T)
            double XXIII = 1 / (6 * nu * rho);


             return (180 / Math.PI) * ((2 * (AtEast - e0)) + (ToEast - e0)) * (AtNorth - ToNorth) * XXIII;
        }

        public static double TrueAzimuth(double AtEast, double AtNorth, double ToEast, double ToNorth, double A, double b, double e0, double n0, double f0, double PHI0)
        {
            //Compute true azimuth in decimal degrees at point (AtEast, AtNorth) to point (ToEast,ToNorth)
            //Input: - _
            //Eastings (AtEast) and Northings (AtNorth) in meters, of point where true azimuth is being computed; _
            //Eastings (ToEast) and Northings (ToNorth) in meters, of point at other end of line to which true azimuth is being computed; _
            //ellipsoid axis dimensions (a & b) and easting & northing (e0 & n0) of true origin in meters; _
            //central meridian scale factor (f0); _
            //latitude of central meridian (PHI0) in decimal degrees.

            //REQUIRES THE "Marc", "InitialLat", "E_N_to_t_minus_T" and "E_N_to_C" FUNCTIONS

            //Compute eastings and northings differences
            double Diffe = ToEast - AtEast;
            double Diffn = ToNorth - AtNorth;
            double GridBearing=0,GridAngle=0, TrueAzimuthOutput=0;
            bool endCompute = false;
            //Compute grid bearing
            if (Diffe == 0)
            {
                if (Diffn < 0)
                    GridBearing = 180;
                else
                    GridBearing = 0;

                endCompute = true;
            }

            if (!endCompute)
            {

                double ratio = Diffn / Diffe;
                GridAngle = (180 / Math.PI) * Math.Atan(ratio);


                if (Diffe > 0)
                    GridBearing = 90 - GridAngle;

                if (Diffe < 0)
                    GridBearing = 270 - GridAngle;

            }

            //ompute convergence
            double Convergence = E_N_to_C(AtEast, AtNorth, A, b, e0, n0, f0, PHI0);

            //Compute (t-T) correction
            double t_minus_T = E_N_to_t_minus_T(AtEast, AtNorth, ToEast, ToNorth, A, b, e0, n0, f0, PHI0);

            //Compute initial azimuth
            double InitAzimuth = GridBearing + Convergence - t_minus_T;



            //Set TrueAzimuth >=0 and <=360
            if (InitAzimuth < 0)
                TrueAzimuthOutput = InitAzimuth + 360;
            else if (InitAzimuth > 360)
                TrueAzimuthOutput = InitAzimuth - 360;
            else
                TrueAzimuthOutput = InitAzimuth;


            return TrueAzimuthOutput;


        }

        public static double Squared(double num) { return Math.Pow(num, 2); }

    
        public static dataTypes.nrgVector2 ENLFromLatLongAlt(double lat, double lng, double alt, double est, double nrth, double lev, transformationSettings ts)
        {
            
            double cx; double cy; double cz;
            double projLat; double projLong;
            double x; double y; double z;

            //cx = Lat_Long_H_to_X(lat * 180 / Math.PI, lng * 180 / Math.PI, alt, ts.WGS84_A, ts.WGS84_B);
            //cy = Lat_Long_H_to_Y(lat * 180 / Math.PI, lng * 180 / Math.PI, alt, ts.WGS84_A, ts.WGS84_B);
            //cz = Lat_H_to_Z(lat * 180 / Math.PI, alt, ts.WGS84_A, ts.WGS84_B);
            cx = Lat_Long_H_to_X(lat, lng, alt, ts.WGS84_A, ts.WGS84_B);
            cy = Lat_Long_H_to_Y(lat, lng, alt, ts.WGS84_A, ts.WGS84_B);
            cz = Lat_H_to_Z(lat, alt, ts.WGS84_A, ts.WGS84_B);
            //cx = Lat_Long_H_to_X(lat, lng, alt, ts.P_A, ts.P_B);
            //cy = Lat_Long_H_to_Y(lat, lng, alt, ts.P_A, ts.P_B);
            //cz = Lat_H_to_Z(lat, alt, ts.P_A, ts.P_B);
            x = Helmert_X(cx, cy, cz, ts.p_translation_parallel_to_X, ts.p_rotation_about_Y, ts.p_rotation_about_Z, ts.p_scale_change);
            y = Helmert_Y(cx, cy, cz, ts.p_translation_parallel_to_Y, ts.p_rotation_about_X, ts.p_rotation_about_Z, ts.p_scale_change);
            z = Helmert_Z(cx, cy, cz, ts.p_translation_parallel_to_Z, ts.p_rotation_about_X, ts.p_rotation_about_Y, ts.p_scale_change);
            projLat = XYZ_to_Lat(x, y, z, ts.P_A, ts.P_B);
            projLong = XYZ_to_Long(x, y);
            if (ts.siteScale == 0)
                ts.siteScale = 1;

            
            est = (Lat_Long_to_East(projLat, projLong, ts.P_A, ts.P_B, ts.P_EO, ts.P_FO, ts.PHIO * 180 / Math.PI, ts.LAMO * 180 / Math.PI) - ts.siteShiftE) / (1 / ts.siteScale);
            nrth = (Lat_Long_to_North(projLat, projLong, ts.P_A, ts.P_B, ts.P_EO, ts.P_NO, ts.P_FO, ts.PHIO * 180 / Math.PI, ts.LAMO * 180 / Math.PI) - ts.siteShiftN) / (1 / ts.siteScale);
            lev = z;

            return new dataTypes.nrgVector2() { X = est, Y = nrth };
        }

        public static dataTypes.nrgVector2 LatLongAltFromENL(double est, double nrth, double lev, double lat, double lng, double alt, transformationSettings ts)
        {
            double cx; double cy; double cz;
            double projLat; double projLong;
            double x; double y; double z;

            est = ((est * (1 / ts.siteScale)) + ts.siteShiftE);
            nrth = ((nrth * (1 / ts.siteScale)) + ts.siteShiftN);

            projLat = E_N_to_Lat(est, nrth, ts.P_A, ts.P_B, ts.P_EO, ts.P_NO, ts.P_FO, ts.PHIO * 180 / Math.PI, ts.LAMO * 180 / Math.PI);
            projLong = E_N_to_Long(est, nrth, ts.P_A, ts.P_B, ts.P_EO, ts.P_NO, ts.P_FO, ts.PHIO * 180 / Math.PI, ts.LAMO * 180 / Math.PI);
            cx = Lat_Long_H_to_X(projLat, projLong, alt, ts.P_A, ts.P_B);
            cy = Lat_Long_H_to_Y(projLat, projLong, alt, ts.P_A, ts.P_B);
            cz = Lat_H_to_Z(projLat, alt, ts.P_A, ts.P_B);
            x = Helmert_X(cx, cy, cz, ts.z_translation_parallel_to_X(), ts.z_rotation_about_Y(), ts.z_rotation_about_Z(), ts.z_scale_change());
            y = Helmert_Y(cx, cy, cz, ts.z_translation_parallel_to_Y(), ts.z_rotation_about_X(), ts.z_rotation_about_Z(), ts.z_scale_change());
            z = Helmert_Z(cx, cy, cz, ts.z_translation_parallel_to_Z(), ts.z_rotation_about_X(), ts.z_rotation_about_Y(), ts.z_scale_change());
            lat = XYZ_to_Lat(x, y, z, ts.WGS84_A, ts.WGS84_B);
            lng = XYZ_to_Long(x, y);
            alt = XYZ_to_H(x, y, z, ts.P_A, ts.P_B);

            return new dataTypes.nrgVector2() { X = lat, Y = lng };
        }

        public int FNonline3(double x1, double y1, double x2, double y2, double x, double y, double tol)
        {
            double diff = (x - x1) * (y2 - y) - (y - y1) * (x2 - x);
            if (Math.Abs(diff) < tol * tol)
                return 0;
            else
                return Math.Sign(diff);
        }

        public static double calcDistBetween2Coords(double lat1, double lng1, double lat2, double lng2, char unit)
        {
            double theta = lng1 - lng2;
            double dist = Math.Sin(degToRad(lat1)) * Math.Sin(degToRad(lat2)) + Math.Cos(degToRad(lat1)) * Math.Cos(degToRad(lat2)) * Math.Cos(degToRad(theta));
            dist = Math.Acos(dist);
            dist = radToDeg(dist);
            dist = dist * 60 * 1.1515;
            if (unit == 'K')
                dist = dist * 1.609344;
            if (unit == 'M')
                dist = dist * 1.609344 * 1000;

            return dist;
        }

        public static double degToRad(double deg)
        {
            return (deg * Math.PI / 180);
        }

        public static double radToDeg(double rad)
        {
            return (rad / Math.PI * 180);
        }
    }
}
