﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using nrgFileRead;
using static AlignmentViewer.workspace;

namespace AlignmentViewer
{


    public class alignments
    {
        enum nstType
        {
            NONE,
            HORIZONTAL,
            LEFTVERTICAL,
            RIGHTVERTICAL,
            VERTICALPOSITION,
            CANTS

        }

        //=================================================================================================
        public class alignment
        {
            public string stringName = "";
            public string stringFile = "";

            public List<dataTypes.nrgVector3> coords = new List<dataTypes.nrgVector3>();

            public horizontalAlignment horizontal { get; set; }
            public verticalAlignment vertical { get; set; }

            /// <summary>
            /// calcDrawCoords.
            /// </summary>
            public alignment()
            {
                horizontal = new horizontalAlignment();
                vertical = new verticalAlignment();
            }

            public dataTypes.nrgVector3Bounds CalcHzExtents()
            {

                dataTypes.nrgVector3Bounds minMax = new dataTypes.nrgVector3Bounds();

                HorizontalElement ele = new HorizontalElement();

                //Just giving it something to test off in the first place
                minMax.minX = horizontal.elements[0].East;
                minMax.minY = horizontal.elements[0].North;
                minMax.maxX = horizontal.elements[0].East;
                minMax.maxY = horizontal.elements[0].North;

                for (int i = 0; i < horizontal.elements.Count; i++)
                {
                    ele = horizontal.elements[i];
                    if (ele.East < minMax.minX) { minMax.minX = ele.East; }
                    if (ele.North < minMax.minY) { minMax.minY = ele.North; }
                    if (ele.East > minMax.maxX) { minMax.maxX = ele.East; }
                    if (ele.North > minMax.maxY) { minMax.maxY = ele.North; }
                }

                //Todo calc bounds for aligntment - last point needed
                return minMax;
            }

            public void calcDrawCoords(List<dataTypes.nrgVector3> coords, double step = 0.1)
            {
                if (horizontal != null)
                {

                    int i = 0;
                    double curCh = 0;
                    double nextCH = 0;
                    double tang = 0;
                    double r = 0;
                    bool OK = false;
                    dataTypes.nrgVector3 vec = new dataTypes.nrgVector3();
                    dataTypes.nrgVector2 thisCoord = new dataTypes.nrgVector2();
                    dataTypes.nrgVector2 nextCoord = new dataTypes.nrgVector2();

                    HorizontalElement thisEle = new HorizontalElement();
                    HorizontalElement lastEle = new HorizontalElement();
                    HorizontalElement nextEle = new HorizontalElement();

                    for (i = 0; i < horizontal.elements.Count - 1; i++)
                    {
                        if (horizontal.elements[i].ElementType == helpers.HorizontalElementType.Straight)
                        {
                            vec = new dataTypes.nrgVector3();
                            vec.X = horizontal.elements[i].East;
                            vec.Y = horizontal.elements[i].North;
                            vec.Z = vertical.GradeLevel(horizontal.elements[i].Chainage);
                            coords.Add(vec);
                            vec = new dataTypes.nrgVector3();
                            vec.X = horizontal.elements[i + 1].East;
                            vec.Y = horizontal.elements[i + 1].North;
                            vec.Z = vertical.GradeLevel(horizontal.elements[i + 1].Chainage);
                            coords.Add(vec);
                        }
                        else
                        {
                            if (i == 0)
                            {
                                lastEle = null;
                                vec = new dataTypes.nrgVector3();
                                vec.X = horizontal.elements[i].East;
                                vec.Y = horizontal.elements[i].North;
                                vec.Z = vertical.GradeLevel(horizontal.elements[i].Chainage);
                                coords.Add(vec);
                            }
                            else
                            {
                                thisEle = horizontal.elements[i];
                                lastEle = horizontal.elements[i - 1];
                                nextEle = horizontal.elements[i + 1];
                                curCh = horizontal.elements[i].Chainage;
                                vec = new dataTypes.nrgVector3();
                                vec.X = horizontal.elements[i].East;
                                vec.Y = horizontal.elements[i].North;
                                vec.Z = vertical.GradeLevel(horizontal.elements[i].Chainage);
                                coords.Add(vec);
                                do
                                {
                                    nextCH = curCh + step;
                                    horizontal.Coords(curCh, thisEle, lastEle, nextEle, ref thisCoord, ref tang, ref r, ref OK);
                                    vec = new dataTypes.nrgVector3();
                                    vec.X = thisCoord.X;
                                    vec.Y = thisCoord.Y;
                                    vec.Z = vertical.GradeLevel(curCh);
                                    coords.Add(vec);
                                    horizontal.Coords(nextCH, thisEle, lastEle, nextEle, ref nextCoord, ref tang, ref r, ref OK);
                                    vec = new dataTypes.nrgVector3();
                                    vec.X = nextCoord.X;
                                    vec.Y = nextCoord.Y;
                                    vec.Z = vertical.GradeLevel(curCh);
                                    coords.Add(vec);

                                    curCh = nextCH;
                                }
                                while (curCh + step < horizontal.elements[i + 1].Chainage);
                            }
                        }
                    }
                }


            }

            /// <summary>
            /// loadFile - Reads the new alignment file format
            /// </summary>
            /// <param name="filename"></param> File path to read...duh
            public void loadFile(string filename = "")
            {
                string txt = "";
                int i = 0;
                string[] Arr;
                string[] splitChars = { "=", "," };
                double elementParam = 0;
                HorizontalElement ele = new HorizontalElement();
                HorizontalElement thisEle = new HorizontalElement();
                HorizontalElement lastEle = new HorizontalElement();
                HorizontalElement nextEle = new HorizontalElement();
                VerticalElement vEle = new VerticalElement();

                if (filename == "")
                {
                    filename = helpers.loadFileDialog("NAF");
                }

                if (filename != "")
                {
                    stringFile = filename;
                    var f = Path.GetFileName(filename);
                    stringName = f.Substring(0, f.Length - 4);
                    var asciiReader = reader.loadAsciiToStringList(filename, false);
                    for (i = 0; i < asciiReader.Count; i++)
                    {
                        txt = asciiReader[i].ToString();
                        if (txt.Length > 2)
                        {
                            if (txt.Substring(0, 2) != "//")
                            {
                                Arr = txt.Split(splitChars, StringSplitOptions.None);
                                if (Arr[0].ToUpper() == "HORIZONTAL ELEMENT")
                                {
                                    ele = new HorizontalElement();
                                    if (Arr[1].ToUpper() == "STRAIGHT")
                                    {
                                        ele.ElementType = helpers.HorizontalElementType.Straight;
                                    }
                                    else if (Arr[1].ToUpper() == "ARC")
                                    {
                                        ele.ElementType = helpers.HorizontalElementType.Arc;
                                    }
                                    else if (Arr[1].ToUpper() == "SPIRAL")
                                    {
                                        ele.ElementType = helpers.HorizontalElementType.Spiral;
                                    }
                                    if (double.TryParse(Arr[2], out elementParam)) { ele.Chainage = elementParam; }

                                    if (double.TryParse(Arr[3], out elementParam)) { ele.East = elementParam; }
                                    if (double.TryParse(Arr[4], out elementParam)) { ele.North = elementParam; }
                                    if (double.TryParse(Arr[5], out elementParam)) { ele.Radius = elementParam; }
                                    if (double.TryParse(Arr[6], out elementParam)) { ele.Length = elementParam; }
                                    horizontal.AddElement(ele);
                                }
                                else if (Arr[0].ToUpper() == "VERTICAL ELEMENT")
                                {
                                    vEle = new VerticalElement();

                                    if (Arr[1].ToUpper() == "STRAIGHT")
                                    {
                                        vEle.ElementType = helpers.verticalElementType.Straight;
                                    }
                                    else if (Arr[1].ToUpper() == "PARABOLA")
                                    {
                                        vEle.ElementType = helpers.verticalElementType.Parabola;
                                    }
                                    if (double.TryParse(Arr[2], out elementParam)) { vEle.Chainage = elementParam; }
                                    if (double.TryParse(Arr[3], out elementParam)) { vEle.Level = elementParam; }
                                    if (double.TryParse(Arr[4], out elementParam)) { vEle.Radius = elementParam; }
                                    vertical.AddElement(vEle);
                                }
                            }
                        }

                    }

                    if (horizontal != null)

                    {
                        if (horizontal.elements.Count > 1)
                        {
                            for (i = 0; i < horizontal.elements.Count - 1; i++)
                            {
                                thisEle = horizontal.elements[i];
                                nextEle = horizontal.elements[i + 1];
                                horizontal.CalcOrigins(ref thisEle, nextEle);
                            }
                        }
                    }
                }
            }


            public void loadNAF(string filename = "")
            {
                string txt = "";
                int i = 0;
                string[] Arr;
                string[] splitChars = { "=", "," };
                double elementParam = 0;
                HorizontalElement ele = new HorizontalElement();
                HorizontalElement thisEle = new HorizontalElement();
                HorizontalElement lastEle = new HorizontalElement();
                HorizontalElement nextEle = new HorizontalElement();
                VerticalElement vEle = new VerticalElement();

                if (filename == "")
                {
                    filename = helpers.loadFileDialog("NAF");
                }

                if (filename != "")
                {
                    stringFile = filename;
                    var f = Path.GetFileName(filename);
                    stringName = f.Substring(0, f.Length - 4);
                    var asciiReader = reader.loadAsciiToStringList(filename, false);
                    for (i = 0; i < asciiReader.Count; i++)
                    {
                        txt = asciiReader[i].ToString();
                        if (txt.Length > 2)
                        {
                            if (txt.Substring(0, 2) != "//")
                            {
                                Arr = txt.Split(splitChars, StringSplitOptions.None);
                                if (Arr[0].ToUpper() == "HORIZONTAL ELEMENT")
                                {
                                    ele = new HorizontalElement();
                                    if (Arr[1].ToUpper() == "STRAIGHT")
                                    {
                                        ele.ElementType = helpers.HorizontalElementType.Straight;
                                    }
                                    else if (Arr[1].ToUpper() == "ARC")
                                    {
                                        ele.ElementType = helpers.HorizontalElementType.Arc;
                                    }
                                    else if (Arr[1].ToUpper() == "SPIRAL")
                                    {
                                        ele.ElementType = helpers.HorizontalElementType.Spiral;
                                    }
                                    if (double.TryParse(Arr[2], out elementParam)) { ele.Chainage = elementParam; }

                                    if (double.TryParse(Arr[3], out elementParam)) { ele.East = elementParam; }
                                    if (double.TryParse(Arr[4], out elementParam)) { ele.North = elementParam; }
                                    if (double.TryParse(Arr[5], out elementParam)) { ele.Radius = elementParam; }
                                    if (double.TryParse(Arr[6], out elementParam)) { ele.Length = elementParam; }
                                    horizontal.AddElement(ele);
                                }
                                else if (Arr[0].ToUpper() == "VERTICAL ELEMENT")
                                {
                                    vEle = new VerticalElement();

                                    if (Arr[1].ToUpper() == "STRAIGHT")
                                    {
                                        vEle.ElementType = helpers.verticalElementType.Straight;
                                    }
                                    else if (Arr[1].ToUpper() == "PARABOLA")
                                    {
                                        vEle.ElementType = helpers.verticalElementType.Parabola;
                                    }
                                    if (double.TryParse(Arr[2], out elementParam)) { vEle.Chainage = elementParam; }
                                    if (double.TryParse(Arr[3], out elementParam)) { vEle.Level = elementParam; }
                                    if (double.TryParse(Arr[4], out elementParam)) { vEle.Radius = elementParam; }
                                    vertical.AddElement(vEle);
                                }
                            }
                        }

                    }

                    if (horizontal != null)

                    {
                        if (horizontal.elements.Count > 1)
                        {
                            for (i = 0; i < horizontal.elements.Count - 1; i++)
                            {
                                thisEle = horizontal.elements[i];
                                nextEle = horizontal.elements[i + 1];
                                horizontal.CalcOrigins(ref thisEle, nextEle);
                            }
                        }
                    }
                }
            }

            public void loadNST(string filename = "")
            {
                //Temp list to load old stuff into before calc
                List<dataTypes.nstHorizontalAlignment> horizontalList = new List<dataTypes.nstHorizontalAlignment>();
                List<dataTypes.nstVerticalAlignment> verticalList = new List<dataTypes.nstVerticalAlignment>();
                List<dataTypes.nstCant> cantList = new List<dataTypes.nstCant>();





                string txt = "";
                int i = 0;
                string[] Arr;
                string[] splitChars = { "=", "," };
                double elementParam = 0;
                HorizontalElement ele = new HorizontalElement();
                HorizontalElement thisEle = new HorizontalElement();
                HorizontalElement lastEle = new HorizontalElement();
                HorizontalElement nextEle = new HorizontalElement();
                VerticalElement vEle = new VerticalElement();





                if (filename == "")
                {
                    filename = helpers.loadFileDialog("NST");
                }

                if (filename != "")
                {
                    stringFile = filename;
                    var f = Path.GetFileName(filename);
                    stringName = f.Substring(0, f.Length - 4);
                    var asciiReader = reader.loadAsciiToStringList(filename, false);
                    alignments.nstType currentProcess = alignments.nstType.NONE;



                    for (i = 0; i < asciiReader.Count; i++)
                    {
                        txt = asciiReader[i].ToString().TrimEnd().TrimStart();

                        //Do if type is horizontal
                        if (!txt.Contains(@"[") && !txt.Contains(";") && currentProcess == alignments.nstType.HORIZONTAL)
                        {


                            var lineData = txt.Split(',');
                            helpers.trimStrings(ref lineData);
                            dataTypes.nstHorizontalAlignment hData = new dataTypes.nstHorizontalAlignment();

                            if (double.TryParse(lineData[0], out elementParam)) { hData.CHSTART = elementParam; }
                            if (double.TryParse(lineData[1], out elementParam)) { hData.CHORIGIN = elementParam; }
                            if (double.TryParse(lineData[2], out elementParam)) { hData.EASTING = elementParam; }
                            if (double.TryParse(lineData[3], out elementParam)) { hData.NORTHING = elementParam; }
                            if (double.TryParse(lineData[4], out elementParam)) { hData.BEARING = elementParam; }
                            if (double.TryParse(lineData[5], out elementParam)) { hData.RADIUS = elementParam; }
                            if (double.TryParse(lineData[6], out elementParam)) { hData.RL = elementParam; }

                            horizontalList.Add(hData);

                        }

                        if (!txt.Contains(@"[") && !txt.Contains(";") && currentProcess == alignments.nstType.LEFTVERTICAL)
                        {
                            var lineData = txt.Split(',');
                            helpers.trimStrings(ref lineData);
                            dataTypes.nstVerticalAlignment vData = new dataTypes.nstVerticalAlignment();

                            if (double.TryParse(lineData[0], out elementParam)) { vData.CHSTART = elementParam; }
                            if (double.TryParse(lineData[1], out elementParam)) { vData.LEVEL = elementParam; }
                            if (double.TryParse(lineData[2], out elementParam)) { vData.RADIUS = elementParam; }

                            verticalList.Add(vData);
                        }

                        if (!txt.Contains(@"[") && !txt.Contains(";") && currentProcess == alignments.nstType.CANTS)
                        {
                            var lineData = txt.Split(',');
                            helpers.trimStrings(ref lineData);
                            dataTypes.nstCant cData = new dataTypes.nstCant();

                            if (double.TryParse(lineData[0], out elementParam)) { cData.CHSTART = elementParam; }

                            for (int idx = 1; idx < lineData.Length; idx++)
                            {
                                if (double.TryParse(lineData[idx], out elementParam)) { cData.CANT.Add(elementParam); }
                            }

                            cantList.Add(cData);

                        }


                        if (!txt.Contains(";") && txt.Equals(@"[CANTS]"))
                        {
                            currentProcess = alignments.nstType.CANTS;
                        }


                        if (!txt.Contains(";") && txt.Equals(@"[LEFT VERTICAL ALIGNMENT]"))
                        {
                            currentProcess = alignments.nstType.LEFTVERTICAL;
                        }

                        if (!txt.Contains(";") && txt.Equals(@"[HORIZONTAL ALIGNMENT]"))
                        {
                            currentProcess = alignments.nstType.HORIZONTAL;
                        }
                        if (!txt.Contains(";") && txt.Equals(@"[VERTICAL ALIGNMENT POSITION]"))
                        {
                            currentProcess = alignments.nstType.NONE;
                        }

                    }

                    //process horizontal alignment


                    double lastrad = 0;
                    double eastStart = 0;
                    double northStart = 0;
                    double radiusStart = 0;
                    double length = 0;
                    bool newEle = false;
                    double eastStart2 = 0;
                    double northStart2 = 0;


                    helpers.HorizontalElementType eleType = new helpers.HorizontalElementType();
                    var hList = horizontalList.ToArray();
                    for (int hIdx = 0; hIdx < hList.Length; hIdx++)
                    {
                        if (hIdx > 1)
                        {
                            lastrad = horizontalList[hIdx].RADIUS;
                        }

                        if(hIdx == (hList.Length -1))
                        {
                            helpers.geometry2Coords(hList[hIdx].CHSTART, hList[hIdx].CHORIGIN, hList[hIdx].EASTING, hList[hIdx].NORTHING, hList[hIdx].BEARING, hList[hIdx].RADIUS, hList[hIdx].RL, lastrad, hList[hIdx].RADIUS, hList[hIdx].CHSTART, ref eleType, ref eastStart, ref northStart, ref radiusStart, ref length, ref newEle, ref eastStart2, ref northStart2);
                        }
                        else
                        {
                            helpers.geometry2Coords(hList[hIdx].CHSTART, hList[hIdx].CHORIGIN, hList[hIdx].EASTING, hList[hIdx].NORTHING, hList[hIdx].BEARING, hList[hIdx].RADIUS, hList[hIdx].RL, lastrad, hList[hIdx + 1].RADIUS, hList[hIdx + 1].CHSTART, ref eleType, ref eastStart, ref northStart, ref radiusStart, ref length, ref newEle, ref eastStart2, ref northStart2);
                        }
                        horizontal.AddElement(new HorizontalElement
                        {
                            Chainage = hList[hIdx].CHSTART,
                            ChainageOrigin = hList[hIdx].CHORIGIN,
                            ElementType = eleType,
                            North = northStart,
                            East = eastStart,
                            Radius = radiusStart,
                            Length = length,
                            rl = hList[hIdx].RL


                        });

                        if (newEle)
                        {
                            horizontal.AddElement(new HorizontalElement
                            {
                                Chainage = hList[hIdx].CHSTART,
                                ChainageOrigin = hList[hIdx].CHORIGIN,
                                ElementType = eleType,
                                North = northStart2,
                                East = eastStart2,
                                Radius = radiusStart,
                                Length = length,
                                rl = hList[hIdx].RL


                            });
                        }
                    }
                    //process vertical alignments
                    //not needed for alignment viewer and slows the process down
                    //var vList = verticalList.ToArray();
                    //for (int vIdx = 0; vIdx < vList.Length; vIdx++)
                    //{

                    //    vertical.AddElement(new VerticalElement
                    //    {
                    //        Chainage = vList[vIdx].CHSTART,
                    //        Level = vList[vIdx].LEVEL,
                    //        Radius = vList[vIdx].RADIUS
                    //    });
                    //}




                    //calc some origin stuff
                    if (horizontal != null)

                    {
                        if (horizontal.elements.Count > 1)
                        {
                            for (i = 0; i < horizontal.elements.Count - 1; i++)
                            {
                                thisEle = horizontal.elements[i];
                                nextEle = horizontal.elements[i + 1];
                                horizontal.CalcOrigins(ref thisEle, nextEle);
                            }
                        }
                    }
                }
            }

            public List<string> loadGPF(string filename)
            {
                stringFile = filename;
                var f = Path.GetFileName(filename);
                stringName = f.Substring(0, f.Length - 4);
                var asciiReader = reader.loadAsciiToStringList(filename, true);
                return asciiReader;


            }

            

            public transformationSettings ReadTransformation(string filename)
            {
                transformationSettings ts;
                long l;
                int count = 0;
                double value;
                string[] tmpData;


                if (filename != "")
                {
                    ts = new transformationSettings();

                    var asciiReader = reader.loadAsciiToStringList(filename, false);
                    ts.name = Path.GetFileNameWithoutExtension(filename);
                    for (int i = 0; i < asciiReader.Count; i++)
                    {
                        tmpData = asciiReader[i].Split('=');
                        value = Convert.ToDouble(tmpData[1]);
                        switch (tmpData[0])
                        {
                            case "WGS84_A":
                                count += 1;
                                ts.WGS84_A = value;
                                break;
                            case "WGS84_B":
                                count += 1;
                                ts.WGS84_B = value;
                                break;
                            case "P_A":
                                count += 1;
                                ts.P_A = value;
                                break;
                            case "P_B":
                                count += 1;
                                ts.P_B = value;
                                break;
                            case "P_FO":
                                count += 1;
                                ts.P_FO = value;
                                break;
                            case "P_EO":
                                count += 1;
                                ts.P_EO = value;
                                break;
                            case "P_NO":
                                count += 1;
                                ts.P_NO = value;
                                break;
                            case "PHIO":
                                count += 1;
                                ts.PHIO = value;
                                break;
                            case "LAMO":
                                count += 1;
                                ts.LAMO = value;
                                break;
                            case "p_translation_parallel_to_X":
                                count += 1;
                                ts.p_translation_parallel_to_X = value;
                                break;
                            case "p_translation_parallel_to_Y":
                                count += 1;
                                ts.p_translation_parallel_to_Y = value;
                                break;
                            case "p_translation_parallel_to_Z":
                                count += 1;
                                ts.p_translation_parallel_to_Z = value;
                                break;
                            case "p_scale_change":
                                count += 1;
                                ts.p_scale_change = value;
                                break;
                            case "p_rotation_about_X":
                                count += 1;
                                ts.p_rotation_about_X = value;
                                break;
                            case "p_rotation_about_Y":
                                count += 1;
                                ts.p_rotation_about_Y = value;
                                break;
                            case "p_rotation_about_Z":
                                count += 1;
                                ts.p_rotation_about_Z = value;
                                break;
                            case "site_shift_e":
                                count += 1;
                                ts.siteShiftE = value;
                                break;
                            case "site_shift_n":
                                count += 1;
                                ts.siteShiftN = value;
                                break;
                            case "site_scale":
                                //Need to check what site scale does, set to 1 always for now
                                //if (value == 0)
                                //    value = 1;
                                if (value != 1)
                                    value = 1;
                                count += 1;
                                ts.siteScale = value;
                                break;
                        }
                    }
                    //Check there is some data
                    if (count >= 16)
                    {
                        return ts;
                    }
                    else
                    {
                        ts = new transformationSettings();
                        ts = createOSTrans();
                        return ts;
                    }

                }
                else
                {
                    ts = new transformationSettings();
                    ts = createOSTrans();
                    return ts;
                }

            }

            public transformationSettings createOSTrans()
            {
                transformationSettings createTrans = new transformationSettings();

                createTrans.name = "OSGB36";
                createTrans.WGS84_A = 6378137; //semi major axis a
                createTrans.WGS84_B = 6356752.3141; //6356256.91   'semi major axis b
                createTrans.P_A = 6377563.396;
                createTrans.P_B = 6356256.91;
                createTrans.P_FO = 0.9996012717;  //origin scale factor
                createTrans.P_EO = 400000D;       //true origin east
                createTrans.P_NO = -100000D;      //true origin north
                createTrans.PHIO = 49D * (Math.PI / 180D);
                createTrans.LAMO = -2D * (Math.PI / 180D);
                //=================================================================
                //******Helmert transformation stuff******
                createTrans.p_translation_parallel_to_X = -446.448;
                createTrans.p_translation_parallel_to_Y = 125.157;
                createTrans.p_translation_parallel_to_Z = -542.06;
                createTrans.p_scale_change = 20.4894;
                createTrans.p_rotation_about_X = -0.1502;
                createTrans.p_rotation_about_Y = -0.247;
                createTrans.p_rotation_about_Z = -0.8421;
                //****************************************
                createTrans.siteShiftE = 0;
                createTrans.siteShiftN = 0;
                createTrans.siteScale = 1;

                return createTrans;
            }


            /// <summary>
            /// Creates a fake two element horizontal alightment, for use on manual single cross section
            /// </summary>
            /// <param name="pt1"></param>The first point
            /// <param name="pt2"></param>And Unsuprising second point
            public void createHorizontalFromPoints(dataTypes.nrgVector3 pt1, dataTypes.nrgVector3 pt2)
            {
                HorizontalElement ele1 = new HorizontalElement();
                HorizontalElement ele2 = new HorizontalElement();

                ele1.ElementType = helpers.HorizontalElementType.Straight;
                ele1.Chainage = 0;
                ele1.East = pt1.X;
                ele1.North = pt1.Y;
                ele1.Radius = 0f;
                ele1.Length = helpers.get2DLengthBetweenXYZ(pt1,pt2);

                ele2.ElementType = helpers.HorizontalElementType.Straight;
                ele2.Chainage = 1;
                ele2.East = pt2.X;
                ele2.North = pt2.Y;
                ele2.Radius = 0f;
                ele2.Length = 0f;

                horizontal.AddElement(ele1);
                horizontal.AddElement(ele2);

                horizontal.CalcOrigins(ref ele1, ele2);

            }

            /// <summary>
            /// saveFile - Saves the new alignment file format
            /// </summary>
            /// <param name="filename"></param> File path to write too
            /// 
            public void saveFile(string filename = "")
            {
                if (filename == "")
                {
                    filename = filename = helpers.saveFileDialog("*.NAF","");
                }

                if (filename != "")
                {
                    if (nrgFileRead.reader.fileExists(filename) == true)
                        nrgFileRead.reader.deleteFile(filename);
                    string outputData = "";
                    string len = "";

                    outputData = "//NRG Alignment" + Environment.NewLine;
                    outputData = outputData + "//Horizontal Alignment=Element Type, Chainage, Easting, Northing, Radius, Spiral Length \r\n" + Environment.NewLine;
                    foreach (HorizontalElement hz in horizontal.elements)

                    {
                        if (hz.ElementType == helpers.HorizontalElementType.Spiral) { len = hz.Length.ToString(); } else { len = "0"; }
                        outputData = outputData + "Horizontal Element=" + hz.ElementType.ToString() + "," + hz.Chainage.ToString() + "," + hz.East.ToString() + "," + hz.North.ToString() + "," + hz.Radius.ToString() + "," + len + "\r\n";
                    }
                    //var asciiWriter = helpers.saveStringToFile(outputData, filename);
                    var writer = nrgFileRead.reader.stringToStream(filename, outputData);
                }

            }

            public void saveNST(string filename = "")
            {
                if(filename == "")
                {
                    filename = filename = helpers.saveFileDialog("*.NST", "");
                }

                if(filename != "")
                {
                    string outputData = "";
                    string len = "";
                    outputData = "FORMAT - NRG NEW STRING FILE VERSION 1.0\r\n\r\n" + "[HORIZONTAL ALIGNMENT]\r\n;CH START     CH ORIGIN     EASTING       NORTHING      BEARING       RADIUS        RL\r\n";
                    foreach(HorizontalElement hz in horizontal.elements)
                    {
                        if(hz.ElementType == helpers.HorizontalElementType.Spiral)
                            len = hz.Length.ToString();
                        else
                            len = "0";

                        if (hz.RadiusOrigin >= 1E+20)
                            hz.RadiusOrigin= 9999999.9990;
                        if (hz == horizontal.elements[horizontal.elements.Count - 1])
                        {
                            outputData = outputData + hz.Chainage.ToString("0.0000") + " ,      " + hz.ChainageOrigin.ToString("0.0000") + " ,      " + hz.East.ToString("0.0000") + " ,               " + hz.North.ToString("0.0000") + " ,               " + hz.BrgOrigin.ToString("0.000000000") + " ,               " + hz.RadiusOrigin.ToString("0.0000") + " ,      ";
                            outputData += hz.rl.ToString("0.0000") + "\r\n";
                        }
                        else
                        {
                            outputData = outputData + hz.Chainage.ToString("0.0000") + " ,      " + hz.ChainageOrigin.ToString("0.0000") + " ,      " + hz.EastOrigin.ToString("0.0000") + " ,               " + hz.NorthOrigin.ToString("0.0000") + " ,               " + hz.BrgOrigin.ToString("0.000000000") + " ,               " + hz.RadiusOrigin.ToString("0.0000") + " ,      ";
                            outputData += hz.rl.ToString("0.0000") + "\r\n";
                        }
                    }


                    if(vertical != null)
                    {
                        if(vertical.elements != null)
                        {
                            outputData += "\r\n[LEFT VERTICAL ALIGNMENT]\r\n" + ";CH START     LEVEL         RADIUS\r\n";
                            foreach (VerticalElement vt in vertical.elements)
                            {
                                outputData += vt.Chainage.ToString("0.0000") + " ,      " + vt.Level.ToString("0.0000") + " ,      " + vt.Radius.ToString("0.0000") + "\r\n";
                            }
                            outputData += "\r\n[VERTICAL ALIGNMENT POSITION]\r\n" + "LOW RAIL = FALSE\r\n" + ";CH START     LEFT ALIGN POS              LEFT EDGE POS RIGHT ALIGN POS             RIGHT EDGE POS, LEFT LEVEL OFFSET, RIGHT LEVEL OFFSET\r\n\r\n";

                            outputData += "[LEFT CARRIAGEWAY]\r\n" + ";CH START     XFALL 1       WIDTH 1       XFALL 2       WIDTH 2       XFALL 3       WIDTH 3       XFALL 4       WIDTH 4       XFALL 5       WIDTH 5\r\n\r\n";
                            outputData += "[RIGHT CARRIAGEWAY]\r\n" + ";CH START     XFALL 1       WIDTH 1       XFALL 2       WIDTH 2       XFALL 3       WIDTH 3       XFALL 4       WIDTH 4       XFALL 5       WIDTH 5\r\n\r\n";
                            outputData += "[LEFT VERGE]\r\n" + ";CH START     XFALL 1       WIDTH 1       RESOIL 1      XFALL 2       WIDTH 2       RESOIL 2      XFALL 3       WIDTH 3       RESOIL 3      XFALL 4       WIDTH 4       RESOIL 4      XFALL 5       WIDTH 5       RESOIL 5\r\n\r\n";
                            outputData += "[CENTRE VERGE]\r\n" + ";CH START     XFALL 1       WIDTH 1       RESOIL 1      XFALL 2       WIDTH 2       RESOIL 2      XFALL 3       WIDTH 3       RESOIL 3      XFALL 4       WIDTH 4       RESOIL 4      XFALL 5       WIDTH 5       RESOIL 5\r\n\r\n";
                            outputData += "[RIGHT VERGE]\r\n" + ";CH START     XFALL 1       WIDTH 1       RESOIL 1      XFALL 2       WIDTH 2       RESOIL 2      XFALL 3       WIDTH 3       RESOIL 3      XFALL 4       WIDTH 4       RESOIL 4      XFALL 5       WIDTH 5       RESOIL 5\r\n\r\n";
                            outputData += "[LEFT BATTER]\r\n" + ";CH START     XFALL 1       WIDTH 1       RESOIL 1      XFALL 2       WIDTH 2       RESOIL 2      XFALL 3       WIDTH 3       RESOIL 3      XFALL 4       WIDTH 4       RESOIL 4      XFALL 5       WIDTH 5       RESOIL 5\r\n\r\n";
                            outputData += "[RIGHT BATTER]\r\n" + ";CH START     XFALL 1       WIDTH 1       RESOIL 1      XFALL 2       WIDTH 2       RESOIL 2      XFALL 3       WIDTH 3       RESOIL 3      XFALL 4       WIDTH 4       RESOIL 4      XFALL 5       WIDTH 5       RESOIL 5\r\n\r\n";
                            outputData += "[LINE FILE]";
                        }
                    }
                    var writer = nrgFileRead.reader.stringToStream(filename, outputData);
                }
            }

        }

        //=================================================================================================

        //=================================================================================================
        public class horizontalAlignment : dataTypes.sourceFile


        {

            //========================================================
            //class level vars
            public List<HorizontalElement> elements { get { return privateElements; } }
            private List<HorizontalElement> privateElements { get; set; }

            //========================================================
            /// <summary>
            /// AddElement - Add a new horizontal element to the alignment. 
            /// Once the new element is added to the list, the whole list is
            /// sorted by chainage
            /// </summary>
            /// <param name="element"></param> new element to add
            public void AddElement(HorizontalElement element)
            {

                if (privateElements == null)
                {
                    //fuck all there so instantiate
                    privateElements = new List<HorizontalElement>();
                }

                //Add to the array thing
                privateElements.Add(element);
                //sort by chainage...still undecided on this, what if the design is in reverse order. Software option?
                privateElements.Sort((x, y) => x.Chainage.CompareTo(y.Chainage));
                //Console.WriteLine(privateElements[0].Chainage);
            }


            /// <summary>
            /// Coords - Stupid name retained for posterity. Calculates the 2D coords(E & N) of a given chainage
            /// </summary>
            /// <param name="Chainage"></param> Chainage (meterage) along the alignemnt (ie geometric distance from the start)
            /// <param name="element"></param> Hz element used for calculation
            /// <param name="previousElement"></param> Hz element which precedes Element
            /// <param name="nextElement"></param> Obvs
            /// <param name="outVector"></param> The Easting & Northing in an nrgVector2
            /// <param name="tang"></param> Tangent bearing at this chainage
            /// <param name="r"></param>Radius at this position
            /// <param name="OK"></param> bool true if it worked, false else.
            public void Coords(double Chainage, HorizontalElement element, HorizontalElement previousElement, HorizontalElement nextElement, ref dataTypes.nrgVector2 outVector, ref double tang, ref double r, ref bool OK)
            {
                double radi = 0, Distance = 0, bearing = 0;
                double tangent = 0, j = 0, l = 0, m = 0;
                double EastO = 0, NorthO = 0;
                double outX = 0, outY = 0;
                Distance = Chainage - element.ChainageOrigin;

                if (element.ElementType == helpers.HorizontalElementType.Straight)
                {
                    bearing = element.BrgOrigin;
                    tangent = bearing;
                    r = 0;
                }
                else if (element.ElementType == helpers.HorizontalElementType.Arc)
                {
                    j = Distance / (element.Radius * 2D);
                    bearing = element.BrgOrigin + j;
                    tangent = element.BrgOrigin + (2D * j);
                    Distance = (2 * element.Radius) * Math.Sin(j);
                    r = element.Radius;
                }
                else //spiral
                {
                    if (Distance == 0)
                    {
                        radi = 1E+38;
                    }
                    else
                    {
                        radi = Math.Abs(element.rl / Distance);
                    }
                    m = Distance / (radi * 2D);
                    j = (m / 3) + ((m * m * m) / 105D) + ((m * m * m * m * m) / 5997D);
                    j = Math.Abs(j);
                    j = Math.Atan(j);
                    tangent = (Distance * Distance) / (2D * Math.Abs(element.rl));
                    tangent = helpers.FNAngle(tangent, 0);
                    if (Chainage > element.ChainageOrigin)
                    {
                        if (nextElement.Radius < 0)
                        {
                            j = -j; tangent = -tangent; r = -radi;
                        }
                        else
                        {
                            r = radi;
                        }
                    }
                    else if (previousElement != null)
                    {
                        if (previousElement.ElementType == helpers.HorizontalElementType.Straight || previousElement.RadiusOrigin > 999999)
                        {
                            //spiral follows straight
                            if (element.RadiusOrigin < 0)
                            {
                                j = -j; tangent = -tangent; r = radi;
                            }
                            else
                            {
                                r = -radi;
                            }
                        }
                        else
                        {
                            if (previousElement.RadiusOrigin > 0)
                            {
                                j = -j; tangent = -tangent; r = radi;
                            }
                            else
                            {
                                r = -radi;
                            }
                        }
                    }
                    else
                    {
                        //shouldn't be able to get here first element is a spiral and the radius is before the spiral origin
                        j = 0; tangent = 0; r = 1E+38;
                    }
                    bearing = element.BrgOrigin + j;
                    tangent = element.BrgOrigin + tangent;
                    tangent = helpers.FNAngle(tangent, 0);

                    l = Distance;

                    Distance = l - ((l * l * l) / (40D * (radi * radi))) + ((l * l * l * l * l) / (3456D * (radi * radi * radi * radi)));
                    Distance = Distance / Math.Cos(j);

                }

                EastO = element.EastOrigin; NorthO = element.NorthOrigin;
                helpers.PRC(EastO, NorthO, bearing, Distance, ref outX, ref outY, 1);
                outVector.X = outX; outVector.Y = outY;
                tang = tangent;
                OK = true;
            }

            /// <summary>
            /// CalcOrigins - Calulates the geometric origins of an alignment given in coordinates
            /// Needed for coordinate / chainage calculations. 
            /// </summary>
            /// <param name="element"></param> Horizontal element of the alignment you wish to use 
            /// <param name="nextElement"></param> Following element is needed for Transition / spiral calculations
            public void CalcOrigins(ref HorizontalElement element, HorizontalElement nextElement)
            {

                double brg = 0, chord = 0;
                bool retry = false;
                double dist = 0;
                do
                {
                    retry = false;
                    if (element.ElementType == helpers.HorizontalElementType.Straight)
                    {
                        element.ChainageOrigin = element.Chainage;
                        element.rl = 0;
                        element.RadiusOrigin = 0;
                        double bo = 0, el = 0;
                        helpers.RPC(element.East, element.North, nextElement.East, nextElement.North, ref bo, ref el, 1);
                        element.BrgOrigin = bo;
                        element.Length = el;
                        element.EastOrigin = element.East;
                        element.NorthOrigin = element.North;
                    }
                    else if (element.ElementType == helpers.HorizontalElementType.Arc)
                    {
                        element.ChainageOrigin = element.Chainage;
                        element.RadiusOrigin = element.Radius;
                        element.rl = 0;
                        helpers.RPC(element.East, element.North, nextElement.East, nextElement.North, ref brg, ref chord, 1);
                        if (chord > 2 * Math.Abs(element.Radius))
                        {
                            element.BrgOrigin = brg;
                            element.Length = chord;
                            element.RadiusOrigin = 0;
                        }
                        else
                        {
                            double deflect = Math.Asin(chord / (2 * element.Radius));
                            element.BrgOrigin = brg - deflect;
                            element.Length = 2 * deflect * element.Radius;

                        }
                        element.EastOrigin = element.East;
                        element.NorthOrigin = element.North;
                    }
                    else //spiral
                    {
                        if (Math.Abs(nextElement.Radius) < 0.0001) { nextElement.Radius = 1E+20; }
                        if (Math.Abs(element.Radius) < 0.0001) { element.Radius = 1E+20; }

                        if (helpers.FNEquals(nextElement.Radius, element.Radius))
                        {
                            element.ElementType = helpers.HorizontalElementType.Arc;
                            retry = true;
                        }
                        else if (helpers.FNEquals(element.Length, 0))
                        {
                            element.RadiusOrigin = 0; element.rl = 0; element.BrgOrigin = 0; element.EastOrigin = element.East; element.NorthOrigin = element.North; element.ChainageOrigin = element.Chainage;
                        }
                        else
                        {
                            double L2 = -element.Length * element.Radius / (element.Radius - nextElement.Radius);
                            double L1 = L2 + element.Length;
                            if (L2 != 0)
                            {
                                element.rl = Math.Abs(L2 * nextElement.Radius);
                            }
                            else
                            {
                                element.rl = Math.Abs(L1 * element.Radius);
                            }

                            double Yb = L2 * L2 / (6D * nextElement.Radius) - L2 * L2 * L2 * L2 / (336D * nextElement.Radius * nextElement.Radius * nextElement.Radius) + L2 * L2 * L2 * L2 * L2 * L2 / (42240D * nextElement.Radius * nextElement.Radius * nextElement.Radius * nextElement.Radius * nextElement.Radius) - L2 * L2 * L2 * L2 * L2 * L2 * L2 * L2 / (9676800D * nextElement.Radius * nextElement.Radius * nextElement.Radius * nextElement.Radius * nextElement.Radius * nextElement.Radius * nextElement.Radius);
                            double Ya = L1 * L1 / (6D * element.Radius) - L1 * L1 * L1 * L1 / (336D * element.Radius * element.Radius * element.Radius) + L1 * L1 * L1 * L1 * L1 * L1 / (42240D * element.Radius * element.Radius * element.Radius * element.Radius * element.Radius) - L1 * L1 * L1 * L1 * L1 * L1 * L1 * L1 / (9676800D * element.Radius * element.Radius * element.Radius * element.Radius * element.Radius * element.Radius * element.Radius);
                            double Yab = Yb - Ya;
                            helpers.RPC(element.East, element.North, nextElement.East, nextElement.North, ref brg, ref dist, 1);
                            double Angle = Math.Asin(Yab / dist);
                            element.BrgOrigin = brg - Angle;
                            double X = L2 - Math.Pow(L2, 3) / (40D * Math.Pow(nextElement.Radius, 2)) + Math.Pow(L2, 5) / (3456D * Math.Pow(nextElement.Radius, 4)) - Math.Pow(L2, 7) / (599040D * Math.Pow(nextElement.Radius, 6));
                            double Y = Math.Pow(L2, 2) / (6D * nextElement.Radius) - Math.Pow(L2, 4) / (336D * Math.Pow(nextElement.Radius, 3)) + Math.Pow(L2, 6) / (42240D * Math.Pow(nextElement.Radius, 5)) - Math.Pow(L2, 8) / (9676800D * Math.Pow(nextElement.Radius, 7));
                            double e = Math.Sin(element.BrgOrigin) * X; double n = Math.Cos(element.BrgOrigin) * X;
                            double e2 = Math.Cos(element.BrgOrigin) * Y; double n2 = Math.Sin(element.BrgOrigin) * Y;
                            element.EastOrigin = nextElement.East + e - e2;
                            element.NorthOrigin = nextElement.North + n + n2;
                            element.RadiusOrigin = element.Radius;
                            if (Math.Abs(element.RadiusOrigin) > 100000000) { element.RadiusOrigin = 0; }
                            element.ChainageOrigin = element.Chainage + L2 + element.Length;
                        }

                    }
                } while (retry == true);
            }




            /// <summary>
            /// getChainageAndOffset - wrapper for compare. Identifys the horizontal element in which a given coordinate
            /// lies, then calculates the chainage & offset
            /// </summary>
            /// <param name="inVector"></param> Vector2 containing the dsired coordinate
            /// <param name="outVector"></param> Vector5 containing Chainage, offset, radius, tangent bearing and element index
            /// <returns></returns> bool true if it worked
            public bool getChainageAndOffset(dataTypes.nrgVector2 inVector, ref dataTypes.nrgAlignmentVector5 outVector)
            {
                int i = 0;
                int lastele = 0;
                double offset = 0;

                dataTypes.nrgAlignmentVector5 testVector = new dataTypes.nrgAlignmentVector5();
                if (privateElements != null)
                {
                    offset = double.PositiveInfinity ;
                    for (i = 0; i < privateElements.Count - 1; i++)
                    {
                        /*
                        if (i == 10) {
                            Debug.WriteLine("This one");
                        }
                        */
                        testVector = new dataTypes.nrgAlignmentVector5();
                        //Compare(inVector, i, testVector, out lastele);

                        if(i == 127)
                        {

                        }
                        if (Compare(inVector, i, testVector,  lastele))
                        {
                            
                            if ((Math.Abs(testVector.offset) < Math.Abs(offset)) )
                            {
                                
                                outVector = testVector;
                                outVector.element = i;
                                offset = outVector.offset;
                      
                            }

                        }
                    }

                }
                if (offset < 1E+38)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }


            /// <summary>
            /// getChainageAndOffset - wrapper for compare. Identifys the horizontal element in which a given coordinate
            /// lies, then calculates the chainage & offset
            /// </summary>
            /// <param name="inVector"></param> Vector2 containing the dsired coordinate
            /// <param name="outVector"></param> Vector5 containing Chainage, offset, radius, tangent bearing and element index
            /// <returns></returns> bool true if it worked
            public bool getChainageAndOffset(dataTypes.nrgVector3 inVector, ref dataTypes.nrgAlignmentVector5 outVector)
            {
                int i = 0;
                int lastele = 0;
                double offset = 0;
                dataTypes.nrgAlignmentVector5 testVector = new dataTypes.nrgAlignmentVector5();
                if (privateElements != null)
                {
                    offset = 1E+38;
                    for (i = 0; i < privateElements.Count - 1; i++)
                    {
                        /*
                        if (i == 10) {
                            Debug.WriteLine("This one");
                        }
                        */
                        testVector = new dataTypes.nrgAlignmentVector5();

                        if (Compare(inVector, i, testVector,  lastele))
                        {

                            if ((Math.Abs(testVector.offset) < Math.Abs(offset)))
                            {

                                outVector = testVector;
                                outVector.element = i;
                                offset = outVector.offset;
                            }

                        }
                    }

                }
                if (offset < 1E+38)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }

            /// <summary>
            /// CoordsAtChAndOffset - Returns the coordinate at a given chainage and offset
            /// </summary>
            /// <param name="ch"></param>Required chainage
            /// <param name="off"></param>Required offset
            /// <returns></returns>Vector2 containing the Easting and Northing 
            public dataTypes.nrgVector2 CoordsAtChAndOffset(double ch, double off)
            {
                double tang = 0, r = 0, bearing = 0, east = 0, north = 0;
                bool OK = false;
                int i = 0;

                dataTypes.nrgVector2 res = new dataTypes.nrgVector2();
                HorizontalElement ele = new HorizontalElement();
                HorizontalElement previousele = new HorizontalElement();
                HorizontalElement nextele = new HorizontalElement();

                if (privateElements != null)
                {
                    for (i = 0; i < privateElements.Count - 1; i++)
                    {
                        ele = privateElements[i + 1];
                        if (ch < ele.Chainage)
                        {
                            break;
                        }
                    }
                    if (i < privateElements.Count - 1)
                    {
                        if (i > 0)
                        {
                            previousele = privateElements[i - 1];
                        }
                        else
                        {
                            previousele = null;
                        }
                        nextele = privateElements[i + 1];
                        ele = privateElements[i];

                        Coords(ch, ele, previousele, nextele, ref res, ref tang, ref r, ref OK);

                    }
                }

                if (OK == true)
                {
                    bearing = tang + Math.PI / 2;
                    if (bearing > 2 * Math.PI) { bearing = bearing - 2 * Math.PI; }
                    helpers.PRC(res.X, res.Y, bearing, off, ref east, ref north, 1);
                    res.X = east;
                    res.Y = north;
                    return res;
                }
                else
                {
                    return null;
                }

            }


            /// <summary>
            /// Compare - Name retained from VB6 code. Probaly the most confusing proc name I've ever come across.
            /// Given a horizontal alignment element, Compare calulates the distance along and offset from the element
            /// Passes back a Vector5 containing chainage, offset, tangent bearing, radius and element index.
            /// Generally called from GetChainageAndOffset.
            /// </summary>
            /// <param name="inVector"></param> Vector2 containing the coordinates of the position to calulate
            /// <param name="ele"></param> index of the hz element
            /// <param name="outVector"></param> vector5 containing chainage, offset, radius and tangent bearing
            /// <param name="lastEle"></param> unused in ported code. Might need in future.
            /// <returns></returns>
            public bool Compare(dataTypes.nrgVector2 inVector, int ele, dataTypes.nrgAlignmentVector5 outVector, int lastEle)
            {
                //=========================================================
                //valid element?
                if (privateElements == null) { lastEle = ele; ; return false; }
                if (ele < 0 || ele >= privateElements.Count - 1) { lastEle = ele; ; return false; }
                //=========================================================
                double theta2 = 0;
                double A = 0, X = 0;
                double brg = 0, dist = 0, theta = 0;
                double tang = 0, r = 0;
                bool OK = false;
                double EastCentre = 0, NorthCentre = 0;
                bool bollocks = false;
                bool found = false;
                dataTypes.nrgVector2 Position = new dataTypes.nrgVector2();

                HorizontalElement element = new HorizontalElement();
                element = privateElements[ele];
                HorizontalElement nextElement = new HorizontalElement();
                nextElement = privateElements[ele + 1];

                //get the geometric origin of spiral / clothoid curves
                //CalcOrigins(ref element, nextElement);

                HorizontalElement previousElement = new HorizontalElement();
                if (ele > 0)
                {
                    previousElement = privateElements[ele - 1];
                }
                else
                {
                    previousElement = null;
                }


                if (element.ElementType == helpers.HorizontalElementType.Straight)
                {
                    helpers.RPC(element.East, element.North, inVector.X, inVector.Y, ref brg, ref dist, 1);
                    theta = brg - element.BrgOrigin;
                    outVector.chainage = (Math.Cos(theta) * dist) + element.ChainageOrigin;
                    outVector.offset = Math.Sin(theta) * dist;
                }
                else if (element.ElementType == helpers.HorizontalElementType.Arc)
                {
                    double Ecentre = element.EastOrigin + (Math.Sin(element.BrgOrigin + Math.PI / 2) * element.Radius);
                    double Ncentre = element.NorthOrigin + (Math.Cos(element.BrgOrigin + Math.PI / 2) * element.Radius);
                    helpers.RPC(Ecentre, Ncentre, inVector.X, inVector.Y, ref brg, ref dist, 1);
                    if (element.Radius < 0)
                    {
                        A = element.BrgOrigin + Math.PI / 2; if (A > 2 * Math.PI) { A = A - 2 * Math.PI; }
                        theta = (A + (2 * Math.PI)) - brg;
                        outVector.offset = element.Radius + dist;
                    }
                    else
                    {
                        A = element.BrgOrigin - Math.PI / 2; if (A < -0.000001) { A = A + 2 * Math.PI; }
                        theta = (brg + (2 * Math.PI)) - A;
                        outVector.offset = element.Radius - dist;
                    }
                    if (helpers.FNEquals2(A, brg, 0.00000001))
                    {
                        outVector.chainage = element.ChainageOrigin;
                    }
                    else
                    {
                        if (theta >= Math.PI) { theta = theta - Math.PI * 2; }
                        outVector.chainage = element.ChainageOrigin + (Math.Abs(element.Radius) * theta);
                    }
                }
                else //spiral
                {
                    int maxtried = 0, tried = 0;
                    double diff = 0, diff2 = 0;

                    //minor differences due to rounding or the origins here - keep an eye!!
                    helpers.RPC(element.EastOrigin, element.NorthOrigin, inVector.X, inVector.Y, ref brg, ref dist, 1);

                    theta = brg - element.BrgOrigin;
                    X = Math.Cos(theta) * dist;
                    outVector.chainage = element.ChainageOrigin + X;

                    if (Math.Abs(element.rl) == 0) { maxtried = 10; }
                    else if (Math.Abs(element.rl) < 100) { maxtried = 60; }
                    else if (Math.Abs(element.rl) >= 100 && Math.Abs(element.rl) <= 500) { maxtried = 50; }
                    else if (Math.Abs(element.rl) > 500 && Math.Abs(element.rl) <= 1000) { maxtried = 40; }
                    else if (Math.Abs(element.rl) > 1000 && Math.Abs(element.rl) <= 10000) { maxtried = 30; }
                    else if (Math.Abs(element.rl) > 10000 && Math.Abs(element.rl) <= 50000) { maxtried = 20; }
                    else { maxtried = 10; }

                    diff = 10000000000;

                    do
                    {
                        diff2 = diff;
                        //call coords here
                        Coords(outVector.chainage, element, previousElement, nextElement, ref Position, ref tang, ref r, ref OK);

                        brg = tang + Math.PI / 2D;
                        helpers.PRC(Position.X, Position.Y, brg, r, ref EastCentre, ref NorthCentre, 1);
                        helpers.RPC(EastCentre, NorthCentre, inVector.X, inVector.Y, ref brg, ref dist, 1);
                        if (r < 0)
                        {
                            outVector.offset = r + dist;
                        }
                        else
                        {
                            outVector.offset = r - dist;
                        }

                        if (r < 0)
                        {
                            theta2 = helpers.FnSmallAngle(brg, (tang + Math.PI / 2D));
                        }
                        else
                        {
                            theta2 = helpers.FnSmallAngle(brg, (tang - Math.PI / 2D));
                        }
                        diff = theta2 * -r;

                        if (Math.Abs(theta2) < 0.00000001 || Math.Abs(diff) < 0.005)
                        {
                            found = true;
                        }
                        else
                        {
                            outVector.chainage = outVector.chainage + diff;
                            found = false;
                            if ((outVector.chainage + Math.Abs(diff) * (maxtried - tried)) < element.Chainage) { found = true; }
                            if ((outVector.chainage - Math.Abs(diff) * (maxtried - tried)) > nextElement.Chainage) { found = true; }

                        }

                        if (Math.Abs(diff) > Math.Abs(diff2))
                        {
                            outVector.chainage = outVector.chainage - diff - 2 * diff2;
                            diff = -diff2;
                        }
                        tried++;

                    }
                    while (found == false && tried <= maxtried);
                
                    if (found == false) { bollocks = true; }

                }

                if (nextElement != null)
                {
                    if (outVector.chainage < nextElement.Chainage && outVector.chainage >= element.Chainage)
                    {
                        found = true;
                    }
                    else if (previousElement == null)
                    {
                        if (outVector.chainage < nextElement.Chainage && outVector.chainage >= element.Chainage)
                        {
                            found = true;
                        }
                        else
                        {
                            found = false;
                        }
                    }
                    else
                    {
                        found = false;
                    }

                }
                if (bollocks == true) {
                    found = false;
                }
                //lastEle = ele;

               
                return found;
            }
        }

        //=================================================================================================

        //================================================================================================= 

        public class verticalAlignment : dataTypes.sourceFile
        {
            public List<VerticalElement> elements { get { return privateElements; } }

            private List<VerticalElement> privateElements { get; set; }

            
            //========================================================
            /// <summary>
            /// AddElement - Add a new horizontal element to the alignment. 
            /// Once the new element is added to the list, the whole list is
            /// sorted by chainage
            /// </summary>
            /// <param name="element"></param> new element to add
            public void AddElement(VerticalElement element)
            {

                if (privateElements == null)
                {
                    // instantiate
                    privateElements = new List<VerticalElement>();
                }

                //Add to the array 
                privateElements.Add(element);
                //sort by chainage
                privateElements.Sort((x, y) => x. Chainage.CompareTo(y.Chainage));
               // Console.WriteLine(privateElements[0].Chainage);
            }

            public int LocateVerticalElement(double chainage)
            {
                int i = 0;
                VerticalElement ele = new VerticalElement();
                if (privateElements  == null)
                {
                    return -1;

                }
                else
                {
                    for (i = 0; i < privateElements.Count - 2; i++)
                    {
                        if (chainage >= privateElements[i].Chainage && chainage <= privateElements[i+1].Chainage) { return i; }
                    }
                    return -1; 
                }


            }

            /// <summary>
            /// GradeLevel  - Calculate the vertical alignment level at a given chainage.
            /// </summary>
            /// <param name="chainage"> Chainage in meters along the alignment that we want to interogate</param>
            /// <returns></returns>

            public double GradeLevel(double chainage)
            {
                double lev = -999;
                int idx = -1;
                double x = 0, l = 0, Y = 0, h = 0, g = 0, m = 0;
                VerticalElement ele = new VerticalElement();
                VerticalElement nextEle = new VerticalElement();

                if (privateElements == null)
                {
                    return -999;
                }
                else if (privateElements.Count == 0)
                {
                    return -999;
                }

                idx = LocateVerticalElement(chainage);
                if (idx < 0 || idx >= privateElements.Count - 1)
                {
                    if (ele.Chainage > chainage)
                    {
                        ele = new VerticalElement();
                        ele = privateElements[0];
                    }
                    else
                    {
                        ele = new VerticalElement();
                        ele = privateElements[privateElements.Count - 1];
                    }
                    return ele.Level;
                }
                else if (idx < privateElements.Count - 1)
                {
                    ele = privateElements[idx];
                    nextEle = privateElements[idx + 1];

                    if (nextEle.Chainage >= ele.Chainage)
                    {
                        x = chainage - ele.Chainage;
                        l = nextEle.Chainage - ele.Chainage;
                        if (l != 0)
                        {
                            if (ele.ElementType == helpers.verticalElementType.Straight)
                            {
                                return helpers.FNInterpolateY(ele.Chainage, ele.Level, nextEle.Chainage, nextEle.Level, chainage);
                            }
                            else
                            {
                                Y = l * l / (2 * ele.Radius);
                                h = nextEle.Level - Y;
                                g = (h - ele.Level) /l ;
                                h = x * x / (2 * ele.Radius);
                                m = (x * g) + ele.Level;
                                return m + h; 

                            }
                        }
                        else
                        {
                            return ele.Level;
                        }

                    }
                    else if (Math.Abs(nextEle.Chainage - ele.Chainage) < 0.001)
                    {
                        return ele.Level;
                    }
                    else
                    {
                        return 0;
                    }
                }
                else if (idx == privateElements.Count - 1)
                {
                    ele = privateElements[privateElements.Count - 1];
                    return ele.Level;
                }
                else
                {
                    return 0;
                }

            }
        }

        public class HorizontalElementDisplay
        {
            public helpers.HorizontalElementType ElementType { get; set; }
            public Double Chainage { get; set; }
            public Double East { get; set; }
            public Double North { get; set; }
            public Double Radius { get; set; }
            public Double Length { get; set; } //for spirals: the length from the optimum radius to 0 or vis versa. 

        }

        public class HorizontalElement
        {
            //=======================================================
            //User editable data
            public helpers.HorizontalElementType ElementType { get; set; }
            public Double Chainage { get; set; }
            public Double East { get; set; }
            public Double North { get; set; }
            public Double Radius { get; set; }
            public Double Length { get; set; } //for spirals: the length from the optimum radius to 0 or vis versa. 
            //=======================================================
            //Extended data - this is calulated but never stored or displayed. Used for chainage & offset calulations
            public  double ChainageOrigin { get; set; }
            public double EastOrigin { get; set; }
            public double NorthOrigin { get; set; }
            public double BrgOrigin { get; set; }
            public double RadiusOrigin { get; set; }
            public double rl { get; set; }
            //=======================================================
            public HorizontalElementDisplay displayElement {
                       
                set {
                     ElementType= value.ElementType;
                     Chainage= value.Chainage;
                     East= value.East;
                     North = value.North;
                     Radius = value.Radius;
                     Length= value.Length;
                     
                    //here

                }
                get {
                    HorizontalElementDisplay newElement = new HorizontalElementDisplay
                    {
                        ElementType = ElementType,
                        Chainage = Chainage,
                        East = East,
                        North = North,
                        Radius = Radius,
                        Length = Length,
                    };
                    return newElement;
                }

            }
        }

        public class VerticalElement
        {
            public helpers.verticalElementType ElementType { get; set; } 
            public Double Chainage { get; set; }
            public Double Level{ get; set; }
            public Double Radius { get; set; }
            
        }

        //=================================================================================================



    }




}
