﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static AlignmentViewer.workspace;

namespace AlignmentViewer
{
    public class transformationSettings
    {
        public string name;

        public double WGS84_A;
        public double WGS84_B;

        public double P_A; //semi major axis a
        public double P_B; //semi major axis b

        public double P_FO; //central meridian scale factor

        public double P_EO; //origin east
        public double P_NO; //north origin
        public double PHIO; //latitude origin
        public double LAMO; //longtitude origin

        //HELMERT TRANSFORMATION CONSTANTS
        //Transformation (WGS84 to OSGB36)
        public double p_translation_parallel_to_X;
        public double p_translation_parallel_to_Y;
        public double p_translation_parallel_to_Z;
        public double p_scale_change;
        public double p_rotation_about_X;
        public double p_rotation_about_Y;
        public double p_rotation_about_Z;

        //===========================================
        public double siteShiftE;
        public double siteShiftN;
        public double siteScale;
        //===========================================

        //Transformation (OSGB36 to WGS84)
  
        //===========================================

        public double z_translation_parallel_to_X()
        {
            return -1 * p_translation_parallel_to_X;
        }

        public double z_translation_parallel_to_Y()
        {
            return -1 * p_translation_parallel_to_Y;
        }

        public double z_translation_parallel_to_Z()
        {
            return -1 * p_translation_parallel_to_Z;
        }

        public double z_scale_change()
        {
            return -1 * p_scale_change;
        }

        public double z_rotation_about_X()
        {
            return -1 * p_rotation_about_X;
        }
        public double z_rotation_about_Y()
        {
            return -1 * p_rotation_about_Y;
        }
        public double z_rotation_about_Z()
        {
            return -1 * p_rotation_about_Z;
        }

    }
}
